from tg import expose, flash, require, url, lurl, request, redirect, tmpl_context
from tg.i18n import ugettext as _, lazy_ugettext as l_
from tg import predicates
from madgraph3 import model
import pickle
import subprocess
import logging
import shutil
import time
import random
log = logging.getLogger(__name__)

from madgraph3.controllers.secure import SecureController
from madgraph3.model import DBSession, metadata
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
import os
from os import system
from sqlalchemy import or_,not_
from sqlalchemy import desc
from madgraph3.lib.base import BaseController
from madgraph3.controllers.error import ErrorController
from set_paths import path_name
import math
#from tw.api import CSSLink
import sys
sys.path.append(path_name("mg5"))

madgraph_path=path_name("mg5")
working_directory=path_name("work")

import madgraph.interface.madgraph_interface as mg_interface
import models as models

__all__ = ['RootController']

identity=request.environ.get('repoze.who.identity')

class adminController(BaseController):
    @expose('madgraph3.templates.admin.index_template')
    def template(self,sort="blug"):
        self.has_permission()
        return{'sort':True}
    @expose()
    def school_mode(self):
        return 'school_mode' in os.listdir(working_directory)
    
    @expose('madgraph3.templates.admin.index')
    def index(self,sort="blug",limit=20,page=1):
        limit=int(limit)
        page=int(page)
        self.has_permission()
        user_list=[]
        n=0
        if sort=="Last run (invert)":
            database=DBSession.query(model.User).order_by(model.User.last_action)
        elif sort=="Last Run":
            database=DBSession.query(model.User).order_by(-model.User.last_action)
        elif sort=="Name":
            database=DBSession.query(model.User).order_by(model.User.user_name)
        elif sort=="Permission":
            database1=DBSession.query(model.User).filter(not_(model.User.auth.contains("default"))).order_by(model.User.auth).all()
            database2=DBSession.query(model.User).filter(model.User.auth.contains("default")).all()
            database=database1+database2
        elif sort=="Running":
            database=DBSession.query(model.User).filter_by(is_running='True')
        else:
            database=DBSession.query(model.User)
        for i in database:
            n+=1
            if n>page*limit or n<=(page-1)*(limit):
                continue
            else:
                user={'name':i.user_name,'num_run':len(i.processes),'auth':i.auth}
                if i.is_running=='False':
                    user['is_running']='False';
                else:
                    self.check_is_running(i.user_name)
                    user['is_running']=i.is_running                
                dt=time.time()-i.last_action
                to_return=""
                if i.last_action == 0:
                    to_return+=" Never "
                elif dt<60:
                    to_return+=" Seconds ago "
                elif dt<60*60:
                    x=int(dt//(60))
                    s="s"
                    if x==1:
                        s=""
                    to_return+= " %s minute%s ago" % (x,s)
                    
                elif dt<60*60*24:
                    x=int(dt//(60*60))
                    s="s"
                    if x==1:
                        s=""
                    to_return+= " %s hour%s ago" % (x,s)
                elif dt<60*60*24*30:
                    x=int(dt//(60*60*24))
                    s="s"
                    if x==1:
                        s=""
                    to_return+= " %s day%s ago" % (x,s)
                elif dt<60*60*24*365:
                    x=int(dt//(60*60*24*30))
                    s="s"
                    if x==1:
                        s=""
                    to_return+= " %s month%s ago" % (x,s)
                else:
                    to_return+=" > 1 year ago"
                user['last_action']=to_return
                user_list.append(user)
        if sort=='Permission':
            total=len(database)
            #return "%s" % total
        else:
            total=database.count()
        numpage=int(math.ceil(float(total)/limit))
        
        limit_data={'sort':sort,'numpage':numpage,'limit':int(limit),'total':total,'page':page}
        #return "%s" % self.has_permission()
        return{'sort':True,'user_list':user_list,'limit':limit_data,'school_mode':"school_mode" in os.listdir(working_directory)}
        
    @expose('')
    def has_permission(self):
        if not request.identity:
            redirect("/auth?message=You have to login to view this page".replace(" ","+"))
        if not request.identity["user"].auth == "admin":
            redirect("/blank?message=Admin only page. Please contact an admin if you need the authorizations.".replace(" ","+"))
    @expose('madgraph3.templates.admin.view_user')
    def view_user(self,user_name,mail_error=False,pwd_changed=False,mail_change=False,pwd_change=False,pwd_error=False,sort="Favorite"):
        self.has_permission()
                
        data={}
        num=-1
        user_list=DBSession.query(model.User).filter_by(user_name=user_name)
        if not user_list.count()==1:
            return("Error, %s users found")%user_list.count()
        user=user_list[0]
        
        user_info=dict(first_name=user.first_name,auth=user.auth,family_name=user.family_name,institution=user.institution,email_address=user.email_address)
        if user.school=="":
            user_info['school']="None"
        else:
            user_info['school']=user.school
        for elem in user.processes:
            num+=1
            n=0
            com_tot={}
            if elem.status == "running":
                self.check_status(user_name,elem.name,num)
            for com in elem.command:
                n+=1
                com_tot["Process %s"%n]=com.value
            data[elem.name]={"code":com_tot,"status":elem.status,"date":elem.date,"date_num":elem.date_num,"fav":elem.fav,"model":elem.model}
        #return "%s"%(data)
        #return "%s" %data
        
        proc_ord=[];    
        if sort=="Date":
            for elem in data:
                if elem in proc_ord:
                    break
                if len(proc_ord)==0:
                    proc_ord.append(elem)
                    first=elem
                else:
                    for i in range(len(proc_ord)):
                        if data[proc_ord[i]]["date_num"]<data[elem]["date_num"]:
                            proc_ord.insert(i,elem)
                            break
                        elif data[proc_ord[i]]["date_num"]==data[elem]["date_num"]:
                            break
                        else:
                            proc_ord.append(elem)
                            break
        elif sort=="Status":
            liste_error=[]
            liste_done=[]
            liste_running=[]
            for elem in data:
                if data[elem]['status']=="running":
                    if len(liste_running)==0:
                        liste_running.append(elem)
                    else:
                        for i in range(len(liste_running)):
                            if data[liste_running[i]]["date_num"]<=data[elem]["date_num"]:
                                liste_running.insert(i,elem)
                                break
                            liste_running.append(elem)
                            break
                if data[elem]['status']=="done":
                    if len(liste_done)==0:
                        liste_done.append(elem)
                    else:
                        for i in range(len(liste_done)):
                            if data[liste_done[i]]["date_num"]<=data[elem]["date_num"]:
                                liste_done.insert(i,elem)
                                break
                            liste_done.append(elem)
                            break
                if data[elem]['status']=="error":
                    if len(liste_error)==0:
                        liste_error.append(elem)
                    else:
                        for i in range(len(liste_error)):
                            if data[liste_error[i]]["date_num"]<=data[elem]["date_num"]:
                                liste_error.insert(i,elem)
                                break
                            liste_error.append(elem)
                            break
            for elem in liste_running:
                proc_ord.append(elem)            
            for elem in liste_done:
                proc_ord.append(elem)
            for elem in liste_error:
                proc_ord.append(elem)
                            
        elif sort=="Favorite":
            liste_fav=[]
            liste_non_fav=[]
            for elem in data:
                if data[elem]['fav']=="True":
                    if len(liste_fav)==0:
                        liste_fav.append(elem)
                    else:
                        for i in range(len(liste_fav)):
                            if data[liste_fav[i]]["date_num"]<=data[elem]["date_num"]:
                                liste_fav.insert(i,elem)
                                break
                            liste_fav.append(elem)
                            break
                else:
                    if len(liste_non_fav)==0:
                        liste_non_fav.append(elem)
                    else:
                        for i in range(len(liste_non_fav)):
                            if data[liste_non_fav[i]]["date_num"]<=data[elem]["date_num"]:
                                liste_non_fav.insert(i,elem)
                                break
                            liste_non_fav.append(elem)
                            break
            for elem in liste_fav:
                proc_ord.append(elem)
            for elem in liste_non_fav:
                proc_ord.append(elem) 
        return dict(user_info=user_info,user_name=user_name,pwd_changed=pwd_changed,proc_ord=proc_ord,data=data,sort=sort,email_change=mail_change,pwd_error=pwd_error,pwd_change=pwd_change)
    
    @expose('')
    def setadmin(self,user,auth):
        self.has_permission()
        if request.identity["user"].user_name==user:
            return("Error, you are not allowed to change your authorizations.")
        user_list=DBSession.query(model.User).filter_by(user_name=user)
        if not user_list.count()==1:
            return("Error, %s users found")%user_list.count()
        user_list[0].auth=auth
        redirect('/adminpage/view_user?user_name=%s'%user)
    
    @expose()
    def delete_all(self,user,fav="gloubiboulga"):
        self.has_permission()
        user_list=DBSession.query(model.User).filter_by(user_name=user)
        if not user_list.count()==1:
            return("Error, %s users found")%user_list.count()
        userdb=user_list[0]
        
        
        os.chdir(working_directory+"/users/"+user)
        """with open("data","rb") as fichier:
            depickler=pickle.Unpickler(fichier)
            data=depickler.load()"""
        data={}
        for elem in userdb.processes:
            n=0
            com_tot={}
            for com in elem.command:
                n+=1
                com_tot["Process %s"%n]=com.value
            data[elem.name]={"code":com_tot,"status":elem.status,"date":elem.date,"date_num":elem.date_num,"fav":elem.fav,"model":elem.model}

        to_del=[]
        if fav=="gloubiboulga":
            redirect("/adminpage/view_user?user_name=%s"%user)
        else:
            if fav=="True":
                for elem in data:
                    if data[elem]['fav']==False:
                        to_del.append(elem)
            if fav=="False":
                for elem in data:
                    to_del.append(elem)
            if fav=="Error":
                for elem in data:
                    if data[elem]['status']=='error':
                        to_del.append(elem)
                             
        for directory in to_del:
            if directory.find("/")>-1 or directory.find("\\")>-1 or directory.find(";")>-1:
                return("ERROR in item to delete")
            try:
                del data[directory]
                x=DBSession.query(model.Process).filter_by(name=directory).filter_by(user=userdb)[0]
                if x.status=='running':
                    pid=""
                    with open(directory+"/running",'r') as fichier:
                        pid=fichier.read();
                    os.system("kill -12 %s"%pid)
                if x.generate_status=='running':
                    pid=""
                    with open(directory+"/generate_running",'r') as fichier:
                        pid=fichier.read();
                    os.system("kill -12 %s"%pid)

                DBSession.delete(x)
            except:
                return("ERROR in item to delete")
            shutil.rmtree(directory+"/")
            os.remove(directory+".mg5")

        redirect("/adminpage/view_user?user_name=%s"%user)
    
    @expose('')
    def remove_dir(self,user="",directory=""):
        self.has_permission()
        if directory.find("/")>-1 or directory.find("\\")>-1 or directory.find(";")>-1:
            return("ERROR in item to delete")
        user_list=DBSession.query(model.User).filter_by(user_name=user)
        if not user_list.count()==1:
            return("Error, %s users found")%user_list.count()
        userdb=user_list[0]
        
        os.chdir(working_directory+"/users/"+user)
        
        try:
            x=DBSession.query(model.Process).filter_by(name=directory).filter_by(user=userdb)[0]
            if x.status=='running':
                pid=""
                with open(directory+"/running",'r') as fichier:
                    pid=fichier.read();
                os.system("kill -12 %s"%pid)
            if x.generate_status=='running':
                pid=""
                with open(directory+"/generate_running",'r') as fichier:
                    pid=fichier.read();
                os.system("kill -12 %s"%pid)

            DBSession.delete(x)
        except:
            return("ERROR!!!")
        """with open("data","rb") as fichier:
            depickler=pickle.Unpickler(fichier)
            data=depickler.load()
        try:
             del data[directory]
        except:
            return("ERROR!!!")
        with open("data","wb") as fichier:
                pickler=pickle.Pickler(fichier)
                pickler.dump(data)
        """
        
        shutil.rmtree(directory+"/")
        redirect("/adminpage/view_user?user_name=%s"%user)
        
    @expose('madgraph3.templates.account.view_process')
    def view_process(self,user,id=""):
        self.has_permission()
        user_list=DBSession.query(model.User).filter_by(user_name=user)
        if not user_list.count()==1:
            return("Error, %s users found")%user_list.count()
        userdb=user_list[0]
        redirect('/users/%s/%s/%s/index.html'%(userdb.user_name,id,id))        
        
    @expose('madgraph3.templates.account.view_log')
    def view_error(self,user,id=""):
        self.has_permission()
        user_list=DBSession.query(model.User).filter_by(user_name=user)
        if not user_list.count()==1:
            return("Error, %s users found")%user_list.count()
        userdb=user_list[0]

        os.chdir(working_directory+"/users/"+userdb.user_name)
        try:
            log=open("%s/MG5_debug"%id,"r")
            log_value=log.read().replace("\n","_nl_").replace("\"","_gui_");
            log.close()
            return{'txt':log_value}
        except:
            return{'txt':"ERROR: unable to read log"}

    
    @expose('madgraph3.templates.account.view_log')
    def view_log(self,user="",id=""):
        self.has_permission()
        user_list=DBSession.query(model.User).filter_by(user_name=user)
        if not user_list.count()==1:
            return("Error, %s users found")%user_list.count()
        userdb=user_list[0]

        os.chdir(working_directory+"/users/"+userdb.user_name)
        try:
            log=open("%s/log.txt"%id,"r")
            log_value=log.read().replace("\n","_nl_").replace("\"","_gui_").replace("[0m","").replace("[1;32m","");
            log.close();
            return{'txt':log_value}
        except:
            return{'txt':"ERROR: unable to read log"}

    @expose()
    def change_mail(self,user,new_email=""):
        self.has_permission()
        user_list=DBSession.query(model.User).filter_by(user_name=user)
        if not user_list.count()==1:
            return("Error, %s users found")%user_list.count()
        if new_email=="":
            redirect('/adminpage/view_user',params=dict(user_name=user,mail_change=False))

        userdb=user_list[0]
        if not DBSession.query(model.User).filter_by(email_address=new_email).count()==0:
            redirect('/adminpage/view_user',params=dict(user_name=user,mail_change=False))
        try:
            userdb.email_address=new_email
        except:
            redirect('/adminpage/view_user',params=dict(user_name=user,mail_change=False))
        redirect('/adminpage/view_user',params=dict(user_name=user,mail_change=True))
            
    @expose('')
    def change_pwd(self,user="",old_pwd="",new_pwd="",new_pwd2=""):
        self.has_permission()
        user_list=DBSession.query(model.User).filter_by(user_name=user)
        if not user_list.count()==1:
            return("Error, %s users found")%user_list.count()
        userdb=user_list[0]

        if not new_pwd==new_pwd2:
            redirect('/adminpage/view_user',params=dict(user_name=user,pwd_error=True))
        else:
            userdb.password=new_pwd
            subprocess.call(["htpasswd","-D","~/Users/users",user])
            subprocess.call(["htpasswd","-b","~/Users/users",user,new_pwd])
            redirect('/adminpage/view_user',params=dict(user_name=user,pwd_changed=True))
    
    @expose('')
    def get_info(self,database):
        self.has_permission()
        user_list=[]
        for i in database:
            user={'name':i.user_name,'num_run':len(i.processes),'auth':i.auth,'f_name':i.first_name,'l_name':i.family_name,'inst':i.institution,'email':i.email_address}
            dt=time.time()-i.last_action
            to_return=""
            if i.last_action == 0:
                to_return+=" Never "
            elif dt<60:
                to_return+=" Seconds ago "
            elif dt<60*60:
                x=int(dt//(60))
                s="s"
                if x==1:
                    s=""
                to_return+= " %s minute%s ago" % (x,s)
                
            elif dt<60*60*24:
                x=int(dt//(60*60))
                s="s"
                if x==1:
                    s=""
                to_return+= " %s hour%s ago" % (x,s)
            elif dt<60*60*24*30:
                x=int(dt//(60*60*24))
                s="s"
                if x==1:
                    s=""
                to_return+= " %s day%s ago" % (x,s)
            elif dt<60*60*24*365:
                x=int(dt//(60*60*24*30))
                s="s"
                if x==1:
                    s=""
                to_return+= " %s month%s ago" % (x,s)
            else:
                to_return+=" > 1 year ago"
            user['last_action']=to_return
            user_list.append(user)
        return user_list
    
    @expose('madgraph3.templates.admin.search')
    def search(self,q=""):
        self.has_permission()
        #DBSession.query(model.User).filter(model.User.user_name.contains(q)).all()
        username=self.get_info(DBSession.query(model.User).filter(model.User.user_name.contains(q)).all())
        email=self.get_info(DBSession.query(model.User).filter(model.User.email_address.contains(q)).all())
        full_name=self.get_info(DBSession.query(model.User).filter(or_(model.User.first_name.contains(q) , model.User.family_name.contains(q))).all())
        data={'q':q,'username':username,'email':email,"full_name":full_name}
        return data
        
    @expose()
    def check_status(self,user_name="",id="",num=-1):
        num=int(num)
        try:
            userdb=DBSession.query(model.User).filter_by(user_name=user_name)[0]
            os.chdir(working_directory+"/users/"+user_name+"/"+id)
        except:
            return("ooops, error %s %s %s"%(user_name,id,num))
        liste=os.listdir(".")
        if "running" in liste:
            return ("it's running")
        else:
            if num==-1:
                return("refresh")
            elif "generation.log" in liste: 
                userdb.processes[num].status='error'
                return("it's broken")
            else:
                userdb.processes[num].status="done"
                try:
                    os.chdir(id)
                except:
                    return("no proc folder")
                liste=os.listdir(".")
                if "RunWeb" in liste:
                    return("it's running")
                else:
                    userdb.processes[num].generate_status="done"
                    userdb.is_running="False"
                    return("it's done")
            
    @expose()
    def check_is_running(self,user_name):
        num=0
        for process in DBSession.query(model.User).filter_by(user_name=user_name)[0].processes:
            x=self.check_status(user_name, process.name,num)
            if x=="it's running":
                return "running"
            num+=1
        DBSession.query(model.User).filter_by(user_name=user_name)[0].is_running='False'
        return "not running"
    
    @expose('madgraph3.templates.admin.school')
    def school(self):
        self.has_permission()
        if self.school_mode():
            file=open(working_directory+'/school_mode')
            content=file.read()
            file.close()
            school_name=content[:content.find("----")]
            user_list=[]
            n=0
            database=DBSession.query(model.User).filter_by(school=school_name)
            for i in database:
                n+=1
                user={'name':i.user_name,'num_run':len(i.processes),'auth':i.auth}
                if i.is_running=='False':
                    user['is_running']='False';
                else:
                    self.check_is_running(i.user_name)
                    user['is_running']=i.is_running                
                dt=time.time()-i.last_action
                to_return=""
                if i.last_action == 0:
                    to_return+=" Never "
                elif dt<60:
                    to_return+=" Seconds ago "
                elif dt<60*60:
                    x=int(dt//(60))
                    s="s"
                    if x==1:
                        s=""
                    to_return+= " %s minute%s ago" % (x,s)
                    
                elif dt<60*60*24:
                    x=int(dt//(60*60))
                    s="s"
                    if x==1:
                        s=""
                    to_return+= " %s hour%s ago" % (x,s)
                elif dt<60*60*24*30:
                    x=int(dt//(60*60*24))
                    s="s"
                    if x==1:
                        s=""
                    to_return+= " %s day%s ago" % (x,s)
                elif dt<60*60*24*365:
                    x=int(dt//(60*60*24*30))
                    s="s"
                    if x==1:
                        s=""
                    to_return+= " %s month%s ago" % (x,s)
                else:
                    to_return+=" > 1 year ago"
                user['last_action']=to_return
                user_list.append(user)
        
            return{'user_list':user_list,'school_on':True,'school_pwd':content[content.find("----")+4:],'school_name':content[:content.find("----")]}
        else:
            return{'user_list':[],'school_on':False}
        return("Ooops, error")
        
    @expose('')
    def new_school(self,school_name,school_pwd):
        self.has_permission()
        if self.school_mode():
            redirect('/adminpage/school')
        os.chdir(working_directory)
        os.system("echo 'x' >> school_mode")
        file=open('school_mode','w')
        file.write(school_name+'----'+school_pwd)
        file.close()
        redirect('/adminpage/school')
    @expose('')
    def stop_school(self):
        self.has_permission()
        os.remove(working_directory+'/school_mode')
        redirect('/adminpage/school')        
    
    @expose('')
    def update_script(self):
        self.has_permission()
        os.chdir("~")
        os.system("./update.sh")
        redirect('/blank?message=Update+script+running.')
    
    @expose('')
    def add_to_school(self,user="",school=""):
        self.has_permission()
        userdb=DBSession.query(model.User).filter_by(user_name=user)
        if not len(userdb.all())==1:
            redirect('/blank?message=Error:+%s+users+found.+User+name:+%s.+School:+%s'%(len(userdb.all())),user,school)
        else:
            userdb[0].school=school
        redirect('/adminpage/view_user?user_name=%s'%user)
        
    @expose('')
    def get_mail(self):
        self.has_permission()
        userdb=DBSession.query(model.User)
        to_return=""
        for elem in userdb:
            if elem.mailing_list==1:
                to_return+=elem.email_address+"\n"
        x=int(1000000*random.random())
        #return(working_directory+'/users/'+str(x))
        os.system("echo 'empty' >>%s"%working_directory+'/users/'+str(x))
        file=open(working_directory+'/users/'+str(x),'w')
        file.write(to_return)
        file.close()
        os.chdir(working_directory+"/users")
        os.system("./delete_file.sh %s &"%(str(x)))
        redirect('/users/'+str(x))
    @expose('')
    def test(self):
        self.has_permission()
        to_return="done :-)"
        
        for i in range(3000):
            u = model.User()
            u.user_name = "test%s"%i
            u.display_name = "test%s@test.com"%i
            u.email_address = "test%s@test.com"%i
            u.password = "test%s"%i
            u.first_name="test user"
            u.family_name="test user"
            u.institution="test"
            u.auth="default"
            u.last_action=0
            model.DBSession.add(u)
            username="test%s"%i
            os.mkdir(working_directory+"/users/"+username)
            shutil.copyfile

        return to_return
        
        