# -*- coding: utf-8 -*-
"""Main Controller"""

from tg import expose, flash, require, url, lurl, request, redirect, tmpl_context
from tg.i18n import ugettext as _, lazy_ugettext as l_
from tg import predicates
from madgraph3 import model
import pickle
import subprocess
import logging
import myaccount , adminpage
log = logging.getLogger(__name__)
import random
import time
import shutil
from set_paths import path_name

from madgraph3.controllers.secure import SecureController
from madgraph3.model import DBSession, metadata
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
import os
from os import system

from madgraph3.lib.base import BaseController
from madgraph3.controllers.error import ErrorController

import sys
sys.path.append(path_name("mg5"))

madgraph_path=path_name("mg5")
working_directory=path_name("work")

import madgraph.interface.madgraph_interface as mg_interface
import madgraph 
import models as models

__all__ = ['RootController']

identity=request.environ.get('repoze.who.identity')

class customobj(object):
    """a simple class"""
    pass

questions={'1':{'q':"What is the full name of 't'?",'a':['top','top quark','quark top']},
           '2':{'q':"What is the full name of 'e-'?",'a':['electron']},
           '3':{'q':"Is an electron lighter than a top quark?",'a':['y','yes']},
           '4':{'q':"What is the full name of 'mu-'?",'a':['muon']},
           '5':{'q':"What is the full name of 'u'?",'a':['up quark','up','quark up']},
           '6':{'q':"What is the full name of 'd'?",'a':['down','down quark','quark down']},
           '7':{'q':"What is the full name of 'c'?",'a':['charm','charm quark','quark charm']},
           '8':{'q':"What is the full name of 's'?",'a':['strange','strange quark','quark strange']},
           '9':{'q':"What is the full name of 'b'?",'a':['bottom','bottom quark','quark bottom']},
           '10':{'q':"How is a bound state of a quark and an antiquark called?",'a':['meson']},
           '11':{'q':"How is a bound state of 3 quarks or 3 antiquark called?",'a':['baryon']},
           '12':{'q':"How is a bound state of quarks called?",'a':['hadron']},
           '13':{'q':"What particles are affected by Pauli's exclusion principle?",'a':['fermions']},
           '14':{'q':"What is the full name of 'g'?",'a':['gluon']},
           }





class RootController(BaseController):
    """
    The root controller for the madgraph-1 application.

    All the other controllers and WSGI applications should be mounted on this
    controller. For example::

        panel = ControlPanelController()
        another_app = AnotherWSGIApplication()

    Keep in mind that WSGI applications shouldn't be mounted directly: They
    must be wrapped around with :class:`tg.controllers.WSGIAppController`.

    """
    secc = SecureController()
    admin = AdminController(model, DBSession, config_type=TGAdminConfig)
    adminpage = adminpage.adminController()
    error = ErrorController()
    myaccount=myaccount.accountController()
    
    def _before(self, *args, **kw):
        tmpl_context.project_name = "madgraph3"
    @expose()
    def school_mode(self):
        return 'school_mode' in os.listdir(working_directory)
    """@expose('madgraph3.templates.index')
    def index(self):
        """"""Handle the front-page.""""""
        return dict(page='index')
"""
    @expose('madgraph3.templates.about')
    def about(self):
        """Handle the 'about' page."""
        return dict(page='about')

    @expose('madgraph3.templates.environ')
    def environ(self):
        """This method showcases TG's access to the wsgi environment."""
        return dict(page='environ', environment=request.environ)

    @expose('madgraph3.templates.data')
    @expose('json')
    def data(self, **kw):
        """This method showcases how you can use the same controller for a data page and a display page"""
        return dict(page='data', params=kw)
    @expose('madgraph3.templates.index')
    @require(predicates.has_permission('manage', msg=l_('Only for managers')))
    def manage_permission_only(self, **kw):
        """Illustrate how a page for managers only works."""
        return dict(page='managers stuff')

    @expose('madgraph3.templates.index')
    @require(predicates.is_user('editor', msg=l_('Only for the editor')))
    def editor_user_only(self, **kw):
        """Illustrate how a page exclusive for the editor works."""
        return dict(page='editor stuff')

    @expose('madgraph3.templates.login')
    def login(self, came_from=lurl('/')):
        """Start the user login."""
        login_counter = request.environ.get('repoze.who.logins', 0)
        if login_counter > 0:
            flash(_('Wrong credentials'), 'warning')
        return dict(page='login', login_counter=str(login_counter),
                    came_from=came_from)

    @expose()
    def post_logout(self, came_from=lurl('/')):
        """
        Redirect the user to the initially requested page on logout and say
        goodbye as well.

        """
        flash(_('We hope to see you soon!'))
        redirect(came_from)
    
    @expose('madgraph3.templates.test.auth')
    def auth(self, came_from=lurl('/'),message_login="",message_register="",first_name="",family_name="",inst="",username="",email="",pwd_corr=False,message=""):
        #identity=request.environ.get('repoze.who.identity')7    
        """Start the user login."""
        login_counter = request.environ.get('repoze.who.logins', 0)
        if login_counter > 0:
            message_login="Wrong login or password."
        if not self.school_mode():
            question_no=str(random.choice(range(len(questions)))+1)
            question=questions[question_no]['q']
        else:
            question="School password:"
            question_no=0
        return dict(page='auth',message_login=message_login,message_register=message_register, login_counter=str(login_counter),
                    came_from=came_from,first_name=first_name,family_name=family_name,inst=inst,username=username,email=email,
                    pwd_corr=pwd_corr,message=message,question=question,question_no=question_no,school_mode=self.school_mode())
        
        """if request.identity:
            return("Logged in!")
        else:
            return("Not logged in :(")"""
    @expose('madgraph3.templates.test.auth')
    def post_login(self, came_from=lurl('/')):
        """
        Redirect the user to the initially requested page on successful
        authentication or redirect her back to the login page if login failed.

        """
        if not request.identity:
            login_counter = request.environ.get('repoze.who.logins', 0) + 1
            redirect('/auth',
                params=dict(came_from=came_from, __logins=login_counter))
        userid = request.identity['repoze.who.userid']
        flash(_('Welcome back, %s!') % userid)
        redirect(came_from)
        
    @expose('madgraph3.templates.test.test_java')
    def madgraph2(self):
        return {'school_mode':self.school_mode()}
    @expose('madgraph3.templates.test.test_java')
    def index(self):
        return {'school_mode':self.school_mode()}
    @expose()
    def process(self,code):
        user_identity=request.identity
        if not user_identity:
            redirect('/auth?message_login=Please+login+to+submit+process&came_from=%s'%lurl('process?code=%s'%code))
        username=user_identity["user"].user_name
        os.chdir(working_directory+"/users/"+username)
        x=int(1000000*random.random())
        name="PROC_%s" % x
        liste=os.listdir(".")
        loopbreak=0;
        while name in liste:
            loopbreak=loopbreak+1
            x=int(1000000*random.random())
            name="PROC_%s" % x
            if loopbreak>100000000:
                return("ERROR.")
        os.mkdir(name)
        
        code=code.replace("_nl_","\n")
        code=code.replace("_di_","#")
        code=code.replace("_pg_",">")
        code=code.replace("_pp_","<")
        code=code.replace("_and_","&")
        code=code.replace("_pv_",";")
        code=code.replace("_gg_","\"")
        code=code.replace("_p_","+")
                
        
        if code.find("output")==-1:
            code+="\noutput %s -f"%name
        
        
        human_code={};
        endroit_generate=code.find("generate")
        human_code["Process 1"]=code[endroit_generate:code.find("\n",endroit_generate)]
        endroit=0
        n=1
        while True:
            endroit=code.find("add process",endroit+1)
            if endroit==-1:
                break
            else:
                n+=1
                endroit_endl=code.find("\n",endroit)
                if endroit_endl> 1:
                    human_code["Process %s"%n]=code[endroit:endroit_endl]
                else:
                    human_code["Process %s"%n]=code[endroit:]
        
        
        fichier=open(name+"/command.mg5","w")
        fichier.write(code)
        fichier.close()
                
        user_path=working_directory+"/users/"+request.identity['user'].user_name
        commande="%s/users/run.sh %s %s %s &"%(working_directory,madgraph_path,user_path,name)
        os.system(commande)
        #subprocess.call(['python', commande, name], stdout=name+"/log.txt", cwd=".")
        
        #    def __init__(self,name,command,date_no,date_str,user_id):
        p=model.Process(user_identity["user"].user_id)
        p.name=name
        p.model=code[code.find("import")+7:code.find("\n",code.find("import"))]
        p.date=time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime())
        p.date_num=time.time()
        p.status='running'
        model.DBSession.add(p)
        pr=user_identity["user"].processes
        for command in human_code:
            c1=model.Command(human_code[command],pr[len(pr)-1].id)
            model.DBSession.add(c1)
            
        user_identity["user"].last_action=time.time()
        user_identity["user"].is_running='True'
        #return "%s" % pr[len(pr)-1].command
        redirect("/myaccount")
    
    
    
    
    @expose('madgraph3.templates.get_order')
    def get_order(self, model='sm', process_id=''):
        """return the element for the order"""

        #1 start Madgraph
        mad = mg_interface.MadGraphCmd()
        #2 load the model
        mad.exec_cmd('import model %s-full' % model.strip())
        #3 find the order (put in list hierarchy)
        hierarchy = mad._curr_model['order_hierarchy'].items()
        
        #names = [o.get('name') for o in self._curr_model['particle_dict'].values()]

        def order(first, second):
            if first[1] < second[1]:
                return -1
            else:
                return 1
        hierarchy.sort(order)
        hierarchy = [str(i[0]) for i in hierarchy]
        #4. return a list of dictionary with the maximal order allowed
        all_order = []
        for order in hierarchy:
            new = customobj()
            all_order.append(new)
            new.name = order
            new.max_order = mad._curr_model['expansion_order'][order]
            if new.max_order <0:
                new.max_order=99

        if (all_order==[]):
            new=customobj()
            all_order.append(new)
            new.name = "no options"
            new.max_order=0
        return {'orders':all_order,'form': process_id}
    
    @expose()
    def get_particles(self,model='sm'):
        """return the particles for the model"""

        #1 start Madgraph
        mad = mg_interface.MadGraphCmd()
        #2 load the model
        mad.exec_cmd('import model %s-full' % model.strip())
        #3 find the particles
        names = [o.get('name') for o in mad._curr_model['particle_dict'].values()]
        names += [o.get('antiname') for o in mad._curr_model['particle_dict'].values()]
        return_string=""
        for name in names:
            return_string+=" %s"%name
        return return_string

    @expose()
    def create_option_list(self,model="sm"):
        to_return=""
        models_path=madgraph_path+"/models"
        list_models = os.listdir(models_path)
        for name in list_models:
            full_name = models_path+"/"+name
            if os.path.isdir(full_name):
                if os.path.exists(full_name+"/__init__.py"):
                    if(name==model):
                        to_return+="<option selected=\"selected\">%s</option>" % name
                    else:
                        to_return+="<option>%s</option>" % name
        return to_return
    
    
    
    @expose()
    def load_option(self,model_name='sm'):
        data=[]
        data2=[]
        code=""
        inverted=""
        if(hasattr(models.load_model(model_name),"build_restrict")==False):
           return("No options <div></div>")
        else:
            categories = models.load_model(model_name).build_restrict.all_categories
            for cat in categories:
                for option in cat:
                    if [model_name,cat.name,option.name,option.default,option.display(False)] not in data2:
                        data2.append([model_name,cat.name,option.name,option.default,option.display(False)])
                        if(option.display(False)):
                            inverted+=",True"
                        else:
                            inverted+=",False"

            for cat in categories:
                code+="<div class=\"categorie\"><big>%s</big><br />"% cat.name
                for option in cat:
                    if [model_name,cat.name,option.name,option.default,option.display(False)] not in data:
                        data.append([model_name,cat.name,option.name,option.default,option.display(False)])
                        if(option.display(option.default)):
                            code+="<input value=\"%s\" class=\"model_option\" type=\"checkbox\" checked=\"checked\">%s</option><br />"%(option.name,option.name)
                        else:
                            code+="<input value=\"%s\" class=\"model_option\" type=\"checkbox\">%s</option><br />"%(option.name,option.name)
                code+="</div>"
        
        return(inverted+"##"+code)
    
    @expose('madgraph3.templates.edit_card')
    def edit(self,code=''):
        """Je sais pas coder..."""
        code=code.replace("_pp_","<");
        code=code.replace("_and_","&");
        code=code.replace("_pv_",";");
        while(code.find("  ")>0):
            code=code.replace("  "," ");
        return{"x":code}
        
        
        
            
            
    @expose('madgraph3.templates.test.register')
    def register(self,first_name="",family_name="",inst="",email="",username="",npassword="",npassword2="",answer="",question_no=""):
        if self.school_mode():
            file=open(working_directory+"/school_mode")
            school_pwd=file.read()
            school_pwd=school_pwd[school_pwd.find("----")+4:]
            file.close()
            #return (school_pwd+"--")
            if not answer == school_pwd:
                redirect('/auth',params=dict(message_register="Incorrect school password. You will be able to register normally tomorrow.",username=username,family_name=family_name,email=email,inst=inst,first_name=first_name))
        else:
            if not answer.lower() in questions[question_no]['a']:
                redirect('/auth',params=dict(message_register="Incorrect answer",username=username,family_name=family_name,email=email,inst=inst,first_name=first_name))
        for letter in username:
            if letter not in "azertyuiopqsdfghjklmwxcvbnAZERTYUIOPMLKJHGFDSQWXCVBN_1234567890":
                redirect('/auth',params=dict(message_register="You can only use letters, numbers and \"_\" in your username.",family_name=family_name,email=email,inst=inst,first_name=first_name))
        
        if len(username)<6:
                redirect('/auth',params=dict(message_register="The username must be minimum 6 characters long.",family_name=family_name,email=email,inst=inst,first_name=first_name))
        if len(npassword)<6:
                redirect('/auth',params=dict(message_register="The password must be minimum 6 characters long.",username=username,family_name=family_name,email=email,inst=inst,first_name=first_name))
        if npassword != npassword2:
            redirect('/auth',params=dict(message_register="Passwords didn't match.",family_name=family_name,username=username,email=email,inst=inst,first_name=first_name))
        
        """with open(working_directory+"/user_list", 'rb') as fichier:
            mdp=pickle.Unpickler(fichier)
            name_list=mdp.load()"""
        if DBSession.query(model.User).filter_by(email_address=email).count()>0:
            redirect('/auth',params=dict(message_register="The email you entered is already used.",family_name=family_name,username=username,inst=inst,first_name=first_name))
        if DBSession.query(model.User).filter_by(user_name=username).count()>0:
            redirect('/auth',params=dict(message_register="The username you entered is already used.",family_name=family_name,email=email,inst=inst,first_name=first_name))
        """name_list.append(email)
        name_list.append(username)
        with open(working_directory+"/user_list", 'wb') as fichier:
            mdp=pickle.Pickler(fichier)
            mdp.dump(name_list)
        names=""
        for elem in name_list:
            names+=elem+"<br/>"
        """
        u = model.User()
        u.user_name = username
        u.display_name = email.replace(".","_")
        u.email_address = email
        u.password = npassword
        u.first_name=first_name
        u.family_name=family_name
        if self.school_mode():
            file=open(working_directory+'/school_mode')
            file_content=file.read()
            file.close()
            u.institution=inst+" school "+file_content[:file_content.find("----")]
            u.school=file_content[:file_content.find("----")]
        else:
            u.institution=inst
        u.auth="default"
        u.last_action=0
        model.DBSession.add(u)
        
        
        email_short=email.replace(".","_")
        os.mkdir(working_directory+"/users/"+username)
        #shutil.copyfile
        subprocess.call(["htpasswd","-b","~/Users/users",username,npassword])
        
        if DBSession.query(model.User).count() == 1:
            DBSession.query(model.User)[0].auth='admin'
            redirect(url('/login_handler', params=dict(came_from='/first_user',login=username,password=npassword, __logins=0)))

        redirect(url('/login_handler', params=dict(came_from='/',login=username,password=npassword, __logins=0)))
    
    @expose('madgraph3.templates.test.firstuser')
    def first_user(self):
        if not request.identity:
            redirect("/auth?message=You have to login to view this page".replace(" ","+"))
        if not request.identity["user"].user_id ==1:
            redirect('/myaccount')
        else:
            return {'user_name':request.identity["user"].user_name}
    @expose('madgraph3.templates.test.header')
    def header(self,):
        return {"log":request.identity}
    @expose()
    def reset(self,came_from=lurl('/'),login="",password=""):
        return "TO DO"
    @expose('madgraph3.templates.blank')
    def blank(self,message):
        return {'message':message}
    @expose()
    def send_card(self,proc_card="",program=""):
        if program=="mg4":
            return("mg4 unavaible for the moment. Please use the old interface")
        code=proc_card.value

        code=code.replace("+","_p_")
        code=code.replace("<","_pp_")
        code=code.replace("&","_and_")
        code=code.replace(";","_pv_")
        code=code.replace(">","_gt_")
        code=code.replace("\"","_gg_")
        code=code.replace("#","_di_")
        code=code.replace("\n","_nl_")
        while(code.find("  ")>0):
            code=code.replace("  "," ")
        page="/edit?code=%s"%code
        redirect(page)
    @expose('madgraph3.templates.contact')
    def contact(self):
        return {'data':None}
    
    @expose('madgraph3.templates.frames')
    def frames(self,link=""):
        return {'link':link}
    
    @expose('madgraph3.templates.frames_banner')
    def frames_banner(self):
        return {'data':None}
    
    @expose('madgraph3.templates.help')
    def help(self,line="",model=""):
        if model=="":
            model="sm"
        
        line=line.replace("__pp__","+")
        #return "%s" % line
        line_splitted=line.split(" ")
        if not line=="":
            line=[""]+line_splitted
        else:
            line=line_splitted
        line_tot=""
        line_pre=[]
        for i in range(len(line)):
            word=line[i]
            line_tot=line_tot+word+" "
            poss=self.complete(line_tot, model=model, javascript=False)
            if poss==None:
                continue
            dict_elem=[]
            dict_elem.append({'value':"",'selected':False})
            for elem in poss:
                if i<len(line)-1 and elem == line[i+1]:
                    dict_elem.append({'value':elem,'selected':True})
                else:
                    dict_elem.append({'value':elem,'selected':False})
            line_pre.append(dict_elem)
        help=""
        try:
            import madgraph.interface.madgraph_interface as cmd
            import StringIO as StringIO
            x = cmd.MadGraphCmd()
            if model=="":
                model="sm"
            x.exec_cmd('import model %s'%model)
            ff= StringIO.StringIO()
            x.do_display(line_tot, output=ff)
            help="%s"%ff.getvalue()
        except Exception,error:
            help="no help available: %s"%error
            help+="\n __%s__"%line_tot
        help=help.split("\n")
        command="display "+line_tot
        models=self.create_option_list(model)
        models=models.replace(" selected=\"selected\"","")
        models=models.split("</option><option>")
        models[0]=models[0].replace("<option>","")
        models[len(models)-1]=models[len(models)-1].replace("</option>","")
        models.remove(model)
        models.insert(0, model)
        return {'line_pre':line_pre,'command':command,'help':help,'models':models}

    
    @expose('')
    def complete(self,line="",model="",javascript=True):
        #redirect('/blank?message=import model %s'%model)
        #redirect('/blank?message=%s'%model)
        try:
            import madgraph.interface.madgraph_interface as cmd
            line="| "+line
            if model=="":
                model="sm"
            x = cmd.MadGraphCmd()
            x.exec_cmd('import model %s'%model)
            if javascript:
                return "%s - %s "%(x.complete_display("",line, len(line),len(line)),line)
            else:
                return x.complete_display("",line, len(line),len(line))
        except Exception,error:
            return(["Error in completion",])

    @expose('')
    def test(self):
        redirect(url('/myaccount'))
        
        """    @expose('madgraph3.templates.completion')
    def completion(self,line="",model=""):
        import madgraph.interface.madgraph_interface as cmd
        import StringIO as StringIO
        if model=="":
            model="sm"
        x = cmd.MadGraphCmd()
        x.exec_cmd('import model %s'%model)
        line_splitted=line.split(" ")
        i=0
        complete_list=[]
        line_tot=""
        for elem in line_splitted:
            line_tot+=elem+" "
            complete_list.append(x.complete_display("",line_tot, len(line_tot),len(line_tot)))
        
        #return("%s - %s - %s"%(complete_list,line_tot,line_splitted))
            
        data={'complete_list':complete_list,'line':line}
        return data
"""
        