# -*- coding: utf-8 -*-
"""Setup the madgraph3 application"""

import logging
from set_paths import path_name
import pickle
from madgraph3.config.environment import load_environment
import os
import subprocess

__all__ = ['setup_app']

log = logging.getLogger(__name__)

from schema import setup_schema
import bootstrap

def setup_app(command, conf, vars):
    user_info={"":"",}
    commande="ln -s %s"% os.path.join(path_name('work'), 'users/')
    subprocess.call(commande,shell=True,cwd=os.path.join(path_name('work'),'madgraph3/public/'))
    
    with open(path_name('work')+"/admin_folder/user_info", 'w+b') as fichier:
            mdp=pickle.Pickler(fichier)
            mdp.dump(user_info)
    name_list=['',]
    with open(path_name('work')+"/user_list", 'w+b') as fichier:
            mdp=pickle.Pickler(fichier)
            mdp.dump(name_list)

    load_environment(conf.global_conf, conf.local_conf)
    setup_schema(command, conf, vars)
    bootstrap.bootstrap(command, conf, vars)
