      SUBROUTINE SMATRIX2(P,ANS)
C     
C     Generated by MadGraph 5 v. 2.0.0.beta3, 2013-02-14
C     By the MadGraph Development Team
C     Please visit us at https://launchpad.net/madgraph5
C     
C     MadGraph for Madevent Version
C     
C     Returns amplitude squared summed/avg over colors
C     and helicities
C     for the point in phase space P(0:3,NEXTERNAL)
C     
C     Process: g d~ > g g g d~ WEIGHTED=4
C     Process: g u~ > g g g u~ WEIGHTED=4
C     Process: g s~ > g g g s~ WEIGHTED=4
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INCLUDE 'genps.inc'
      INCLUDE 'maxconfigs.inc'
      INCLUDE 'nexternal.inc'
      INCLUDE 'maxamps.inc'
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=64)
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=159)
      INTEGER    NDIAGS
      PARAMETER (NDIAGS=123)
      INTEGER    THEL
      PARAMETER (THEL=2*NCOMB)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL),ANS
C     
C     LOCAL VARIABLES 
C     
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY(2)
      INTEGER ISHEL(2)
      REAL*8 T,MATRIX2
      REAL*8 R,SUMHEL,TS(NCOMB)
      INTEGER I,IDEN
      INTEGER JC(NEXTERNAL),II
      LOGICAL GOODHEL(NCOMB,2)
      REAL*8 HWGT, XTOT, XTRY, XREJ, XR, YFRAC(0:NCOMB)
      INTEGER NGOOD(2), IGOOD(NCOMB,2)
      INTEGER JHEL(2), J, JJ
C     
C     GLOBAL VARIABLES
C     
      DOUBLE PRECISION AMP2(MAXAMPS), JAMP2(0:MAXFLOW)
      COMMON/TO_AMPS/  AMP2,       JAMP2

      CHARACTER*101         HEL_BUFF
      COMMON/TO_HELICITY/  HEL_BUFF

      INTEGER IMIRROR
      COMMON/TO_MIRROR/ IMIRROR

      REAL*8 POL(2)
      COMMON/TO_POLARIZATION/ POL

      INTEGER          ISUM_HEL
      LOGICAL                    MULTI_CHANNEL
      COMMON/TO_MATRIX/ISUM_HEL, MULTI_CHANNEL
      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
      COMMON/TO_MCONFIGS/MAPCONFIG, ICONFIG
      INTEGER SUBDIAG(MAXSPROC),IB(2)
      COMMON/TO_SUB_DIAG/SUBDIAG,IB
      DATA XTRY, XREJ /0,0/
      DATA NTRY /0,0/
      DATA NGOOD /0,0/
      DATA ISHEL/0,0/
      SAVE YFRAC, IGOOD, JHEL
      DATA GOODHEL/THEL*.FALSE./
      DATA (NHEL(I,   1),I=1,6) /-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,   2),I=1,6) /-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,   3),I=1,6) /-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,   4),I=1,6) /-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,   5),I=1,6) /-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,   6),I=1,6) /-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,   7),I=1,6) /-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,   8),I=1,6) /-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,   9),I=1,6) /-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  10),I=1,6) /-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  11),I=1,6) /-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  12),I=1,6) /-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  13),I=1,6) /-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  14),I=1,6) /-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  15),I=1,6) /-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  16),I=1,6) /-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  17),I=1,6) /-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  18),I=1,6) /-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  19),I=1,6) /-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  20),I=1,6) /-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  21),I=1,6) /-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  22),I=1,6) /-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  23),I=1,6) /-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  24),I=1,6) /-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  25),I=1,6) /-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  26),I=1,6) /-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  27),I=1,6) /-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  28),I=1,6) /-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  29),I=1,6) /-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  30),I=1,6) /-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  31),I=1,6) /-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  32),I=1,6) /-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  33),I=1,6) / 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  34),I=1,6) / 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  35),I=1,6) / 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  36),I=1,6) / 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  37),I=1,6) / 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  38),I=1,6) / 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  39),I=1,6) / 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  40),I=1,6) / 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  41),I=1,6) / 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  42),I=1,6) / 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  43),I=1,6) / 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  44),I=1,6) / 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  45),I=1,6) / 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  46),I=1,6) / 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  47),I=1,6) / 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  48),I=1,6) / 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  49),I=1,6) / 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  50),I=1,6) / 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  51),I=1,6) / 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  52),I=1,6) / 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  53),I=1,6) / 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  54),I=1,6) / 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  55),I=1,6) / 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  56),I=1,6) / 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  57),I=1,6) / 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  58),I=1,6) / 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  59),I=1,6) / 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  60),I=1,6) / 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  61),I=1,6) / 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  62),I=1,6) / 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  63),I=1,6) / 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  64),I=1,6) / 1, 1, 1, 1, 1, 1/
      DATA IDEN/576/
C     ----------
C     BEGIN CODE
C     ----------
      NTRY(IMIRROR)=NTRY(IMIRROR)+1
      DO I=1,NEXTERNAL
        JC(I) = +1
      ENDDO

      IF (MULTI_CHANNEL) THEN
        DO I=1,NDIAGS
          AMP2(I)=0D0
        ENDDO
        JAMP2(0)=24
        DO I=1,INT(JAMP2(0))
          JAMP2(I)=0D0
        ENDDO
      ENDIF
      ANS = 0D0
      WRITE(HEL_BUFF,'(20I5)') (0,I=1,NEXTERNAL)
      DO I=1,NCOMB
        TS(I)=0D0
      ENDDO
      IF (ISHEL(IMIRROR) .EQ. 0 .OR. NTRY(IMIRROR) .LE. MAXTRIES) THEN
        DO I=1,NCOMB
          IF (GOODHEL(I,IMIRROR) .OR. NTRY(IMIRROR).LE.MAXTRIES) THEN
            T=MATRIX2(P ,NHEL(1,I),JC(1))
            DO JJ=1,NINCOMING
              IF(POL(JJ).NE.1D0.AND.NHEL(JJ,I).EQ.INT(SIGN(1D0
     $         ,POL(JJ)))) THEN
                T=T*ABS(POL(JJ))
              ELSE IF(POL(JJ).NE.1D0)THEN
                T=T*(2D0-ABS(POL(JJ)))
              ENDIF
            ENDDO
            ANS=ANS+DABS(T)
            TS(I)=T
          ENDIF
        ENDDO
        JHEL(IMIRROR) = 1
        IF(NTRY(IMIRROR).LE.MAXTRIES)THEN
          DO I=1,NCOMB
            IF (.NOT.GOODHEL(I,IMIRROR) .AND. (DABS(TS(I)).GT.ANS
     $       *LIMHEL/NCOMB)) THEN
              GOODHEL(I,IMIRROR)=.TRUE.
              NGOOD(IMIRROR) = NGOOD(IMIRROR) +1
              IGOOD(NGOOD(IMIRROR),IMIRROR) = I
              PRINT *,'Added good helicity ',I,TS(I)*NCOMB/ANS
     $         ,' in event ',NTRY(IMIRROR)
            ENDIF
          ENDDO
        ENDIF
        IF(NTRY(IMIRROR).EQ.MAXTRIES)THEN
          ISHEL(IMIRROR)=MIN(ISUM_HEL,NGOOD(IMIRROR))
        ENDIF
      ELSE  !LOOP OVER GOOD HELICITIES
        DO J=1,ISHEL(IMIRROR)
          JHEL(IMIRROR)=JHEL(IMIRROR)+1
          IF (JHEL(IMIRROR) .GT. NGOOD(IMIRROR)) JHEL(IMIRROR)=1
          HWGT = REAL(NGOOD(IMIRROR))/REAL(ISHEL(IMIRROR))
          I = IGOOD(JHEL(IMIRROR),IMIRROR)
          T=MATRIX2(P ,NHEL(1,I),JC(1))
          DO JJ=1,NINCOMING
            IF(POL(JJ).NE.1D0.AND.NHEL(JJ,I).EQ.INT(SIGN(1D0,POL(JJ)))
     $       ) THEN
              T=T*ABS(POL(JJ))
            ELSE IF(POL(JJ).NE.1D0)THEN
              T=T*(2D0-ABS(POL(JJ)))
            ENDIF
          ENDDO
          ANS=ANS+DABS(T)*HWGT
          TS(I)=T*HWGT
        ENDDO
        IF (ISHEL(IMIRROR) .EQ. 1) THEN
          WRITE(HEL_BUFF,'(20i5)')(NHEL(II,I),II=1,NEXTERNAL)
C         Set right sign for ANS, based on sign of chosen helicity
          ANS=DSIGN(ANS,TS(I))
        ENDIF
      ENDIF
      IF (ISHEL(IMIRROR) .NE. 1) THEN
        CALL RANMAR(R)
        SUMHEL=0D0
        DO I=1,NCOMB
          SUMHEL=SUMHEL+DABS(TS(I))/ANS
          IF(R.LT.SUMHEL)THEN
            WRITE(HEL_BUFF,'(20i5)')(NHEL(II,I),II=1,NEXTERNAL)
C           Set right sign for ANS, based on sign of chosen helicity
            ANS=DSIGN(ANS,TS(I))
            GOTO 10
          ENDIF
        ENDDO
 10     CONTINUE
      ENDIF
      IF (MULTI_CHANNEL) THEN
        XTOT=0D0
        DO I=1,NDIAGS
          XTOT=XTOT+AMP2(I)
        ENDDO
        IF (XTOT.NE.0D0) THEN
          ANS=ANS*AMP2(SUBDIAG(2))/XTOT
        ELSE
          ANS=0D0
        ENDIF
      ENDIF
      ANS=ANS/DBLE(IDEN)
      END


      REAL*8 FUNCTION MATRIX2(P,NHEL,IC)
C     
C     Generated by MadGraph 5 v. 2.0.0.beta3, 2013-02-14
C     By the MadGraph Development Team
C     Please visit us at https://launchpad.net/madgraph5
C     
C     Returns amplitude squared summed/avg over colors
C     for the point with external lines W(0:6,NEXTERNAL)
C     
C     Process: g d~ > g g g d~ WEIGHTED=4
C     Process: g u~ > g g g u~ WEIGHTED=4
C     Process: g s~ > g g g s~ WEIGHTED=4
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=159)
      INCLUDE 'genps.inc'
      INCLUDE 'nexternal.inc'
      INCLUDE 'maxamps.inc'
      INTEGER    NWAVEFUNCS,     NCOLOR
      PARAMETER (NWAVEFUNCS=26, NCOLOR=24)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J
      COMPLEX*16 ZTEMP
      REAL*8 DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(6,NWAVEFUNCS)
C     Needed for v4 models
      COMPLEX*16 DUM0,DUM1
      DATA DUM0, DUM1/(0D0, 0D0), (1D0, 0D0)/
C     
C     GLOBAL VARIABLES
C     
      DOUBLE PRECISION AMP2(MAXAMPS), JAMP2(0:MAXFLOW)
      COMMON/TO_AMPS/  AMP2,       JAMP2
      INCLUDE 'coupl.inc'
C     
C     COLOR DATA
C     
      DATA DENOM(1)/54/
      DATA (CF(I,  1),I=  1,  6) /  512,  -64,  -64,    8,    8,   80/
      DATA (CF(I,  1),I=  7, 12) /  -64,    8,    8,   -1,   -1,  -10/
      DATA (CF(I,  1),I= 13, 18) /    8,   -1,   80,  -10,   71,   62/
      DATA (CF(I,  1),I= 19, 24) /   -1,  -10,  -10,   62,   62,  -28/
C     1 T(1,3,4,5,2,6)
      DATA DENOM(2)/54/
      DATA (CF(I,  2),I=  1,  6) /  -64,  512,    8,   80,  -64,    8/
      DATA (CF(I,  2),I=  7, 12) /    8,  -64,   -1,  -10,    8,   -1/
      DATA (CF(I,  2),I= 13, 18) /   -1,  -10,  -10,   62,   62,  -28/
      DATA (CF(I,  2),I= 19, 24) /    8,   -1,   80,  -10,   71,   62/
C     1 T(1,3,5,4,2,6)
      DATA DENOM(3)/54/
      DATA (CF(I,  3),I=  1,  6) /  -64,    8,  512,  -64,   80,    8/
      DATA (CF(I,  3),I=  7, 12) /    8,   -1,   80,  -10,   71,   62/
      DATA (CF(I,  3),I= 13, 18) /  -64,    8,    8,   -1,   -1,  -10/
      DATA (CF(I,  3),I= 19, 24) /  -10,   -1,   62,  -28,  -10,   62/
C     1 T(1,4,3,5,2,6)
      DATA DENOM(4)/54/
      DATA (CF(I,  4),I=  1,  6) /    8,   80,  -64,  512,    8,  -64/
      DATA (CF(I,  4),I=  7, 12) /   -1,  -10,  -10,   62,   62,  -28/
      DATA (CF(I,  4),I= 13, 18) /    8,  -64,   -1,  -10,    8,   -1/
      DATA (CF(I,  4),I= 19, 24) /   -1,    8,   71,   62,   80,  -10/
C     1 T(1,4,5,3,2,6)
      DATA DENOM(5)/54/
      DATA (CF(I,  5),I=  1,  6) /    8,  -64,   80,    8,  512,  -64/
      DATA (CF(I,  5),I=  7, 12) /   -1,    8,   71,   62,   80,  -10/
      DATA (CF(I,  5),I= 13, 18) /  -10,   -1,   62,  -28,  -10,   62/
      DATA (CF(I,  5),I= 19, 24) /  -64,    8,    8,   -1,   -1,  -10/
C     1 T(1,5,3,4,2,6)
      DATA DENOM(6)/54/
      DATA (CF(I,  6),I=  1,  6) /   80,    8,    8,  -64,  -64,  512/
      DATA (CF(I,  6),I=  7, 12) /  -10,   -1,   62,  -28,  -10,   62/
      DATA (CF(I,  6),I= 13, 18) /   -1,    8,   71,   62,   80,  -10/
      DATA (CF(I,  6),I= 19, 24) /    8,  -64,   -1,  -10,    8,   -1/
C     1 T(1,5,4,3,2,6)
      DATA DENOM(7)/54/
      DATA (CF(I,  7),I=  1,  6) /  -64,    8,    8,   -1,   -1,  -10/
      DATA (CF(I,  7),I=  7, 12) /  512,  -64,  -64,    8,    8,   80/
      DATA (CF(I,  7),I= 13, 18) /   80,  -10,    8,   -1,   62,   71/
      DATA (CF(I,  7),I= 19, 24) /  -10,   62,   -1,  -10,  -28,   62/
C     1 T(3,1,4,5,2,6)
      DATA DENOM(8)/54/
      DATA (CF(I,  8),I=  1,  6) /    8,  -64,   -1,  -10,    8,   -1/
      DATA (CF(I,  8),I=  7, 12) /  -64,  512,    8,   80,  -64,    8/
      DATA (CF(I,  8),I= 13, 18) /  -10,   62,   -1,  -10,  -28,   62/
      DATA (CF(I,  8),I= 19, 24) /   80,  -10,    8,   -1,   62,   71/
C     1 T(3,1,5,4,2,6)
      DATA DENOM(9)/54/
      DATA (CF(I,  9),I=  1,  6) /    8,   -1,   80,  -10,   71,   62/
      DATA (CF(I,  9),I=  7, 12) /  -64,    8,  512,  -64,   80,    8/
      DATA (CF(I,  9),I= 13, 18) /    8,   -1,  -64,    8,  -10,   -1/
      DATA (CF(I,  9),I= 19, 24) /   62,  -28,  -10,   -1,   62,  -10/
C     1 T(3,4,1,5,2,6)
      DATA DENOM(10)/54/
      DATA (CF(I, 10),I=  1,  6) /   -1,  -10,  -10,   62,   62,  -28/
      DATA (CF(I, 10),I=  7, 12) /    8,   80,  -64,  512,    8,  -64/
      DATA (CF(I, 10),I= 13, 18) /   -1,  -10,    8,  -64,   -1,    8/
      DATA (CF(I, 10),I= 19, 24) /   71,   62,   -1,    8,  -10,   80/
C     1 T(3,4,5,1,2,6)
      DATA DENOM(11)/54/
      DATA (CF(I, 11),I=  1,  6) /   -1,    8,   71,   62,   80,  -10/
      DATA (CF(I, 11),I=  7, 12) /    8,  -64,   80,    8,  512,  -64/
      DATA (CF(I, 11),I= 13, 18) /   62,  -28,  -10,   -1,   62,  -10/
      DATA (CF(I, 11),I= 19, 24) /    8,   -1,  -64,    8,  -10,   -1/
C     1 T(3,5,1,4,2,6)
      DATA DENOM(12)/54/
      DATA (CF(I, 12),I=  1,  6) /  -10,   -1,   62,  -28,  -10,   62/
      DATA (CF(I, 12),I=  7, 12) /   80,    8,    8,  -64,  -64,  512/
      DATA (CF(I, 12),I= 13, 18) /   71,   62,   -1,    8,  -10,   80/
      DATA (CF(I, 12),I= 19, 24) /   -1,  -10,    8,  -64,   -1,    8/
C     1 T(3,5,4,1,2,6)
      DATA DENOM(13)/54/
      DATA (CF(I, 13),I=  1,  6) /    8,   -1,  -64,    8,  -10,   -1/
      DATA (CF(I, 13),I=  7, 12) /   80,  -10,    8,   -1,   62,   71/
      DATA (CF(I, 13),I= 13, 18) /  512,  -64,  -64,    8,    8,   80/
      DATA (CF(I, 13),I= 19, 24) /   62,  -10,  -28,   62,   -1,  -10/
C     1 T(4,1,3,5,2,6)
      DATA DENOM(14)/54/
      DATA (CF(I, 14),I=  1,  6) /   -1,  -10,    8,  -64,   -1,    8/
      DATA (CF(I, 14),I=  7, 12) /  -10,   62,   -1,  -10,  -28,   62/
      DATA (CF(I, 14),I= 13, 18) /  -64,  512,    8,   80,  -64,    8/
      DATA (CF(I, 14),I= 19, 24) /  -10,   80,   62,   71,    8,   -1/
C     1 T(4,1,5,3,2,6)
      DATA DENOM(15)/54/
      DATA (CF(I, 15),I=  1,  6) /   80,  -10,    8,   -1,   62,   71/
      DATA (CF(I, 15),I=  7, 12) /    8,   -1,  -64,    8,  -10,   -1/
      DATA (CF(I, 15),I= 13, 18) /  -64,    8,  512,  -64,   80,    8/
      DATA (CF(I, 15),I= 19, 24) /  -28,   62,   62,  -10,  -10,   -1/
C     1 T(4,3,1,5,2,6)
      DATA DENOM(16)/54/
      DATA (CF(I, 16),I=  1,  6) /  -10,   62,   -1,  -10,  -28,   62/
      DATA (CF(I, 16),I=  7, 12) /   -1,  -10,    8,  -64,   -1,    8/
      DATA (CF(I, 16),I= 13, 18) /    8,   80,  -64,  512,    8,  -64/
      DATA (CF(I, 16),I= 19, 24) /   62,   71,  -10,   80,   -1,    8/
C     1 T(4,3,5,1,2,6)
      DATA DENOM(17)/54/
      DATA (CF(I, 17),I=  1,  6) /   71,   62,   -1,    8,  -10,   80/
      DATA (CF(I, 17),I=  7, 12) /   62,  -28,  -10,   -1,   62,  -10/
      DATA (CF(I, 17),I= 13, 18) /    8,  -64,   80,    8,  512,  -64/
      DATA (CF(I, 17),I= 19, 24) /   -1,    8,  -10,   -1,  -64,    8/
C     1 T(4,5,1,3,2,6)
      DATA DENOM(18)/54/
      DATA (CF(I, 18),I=  1,  6) /   62,  -28,  -10,   -1,   62,  -10/
      DATA (CF(I, 18),I=  7, 12) /   71,   62,   -1,    8,  -10,   80/
      DATA (CF(I, 18),I= 13, 18) /   80,    8,    8,  -64,  -64,  512/
      DATA (CF(I, 18),I= 19, 24) /  -10,   -1,   -1,    8,    8,  -64/
C     1 T(4,5,3,1,2,6)
      DATA DENOM(19)/54/
      DATA (CF(I, 19),I=  1,  6) /   -1,    8,  -10,   -1,  -64,    8/
      DATA (CF(I, 19),I=  7, 12) /  -10,   80,   62,   71,    8,   -1/
      DATA (CF(I, 19),I= 13, 18) /   62,  -10,  -28,   62,   -1,  -10/
      DATA (CF(I, 19),I= 19, 24) /  512,  -64,  -64,    8,    8,   80/
C     1 T(5,1,3,4,2,6)
      DATA DENOM(20)/54/
      DATA (CF(I, 20),I=  1,  6) /  -10,   -1,   -1,    8,    8,  -64/
      DATA (CF(I, 20),I=  7, 12) /   62,  -10,  -28,   62,   -1,  -10/
      DATA (CF(I, 20),I= 13, 18) /  -10,   80,   62,   71,    8,   -1/
      DATA (CF(I, 20),I= 19, 24) /  -64,  512,    8,   80,  -64,    8/
C     1 T(5,1,4,3,2,6)
      DATA DENOM(21)/54/
      DATA (CF(I, 21),I=  1,  6) /  -10,   80,   62,   71,    8,   -1/
      DATA (CF(I, 21),I=  7, 12) /   -1,    8,  -10,   -1,  -64,    8/
      DATA (CF(I, 21),I= 13, 18) /  -28,   62,   62,  -10,  -10,   -1/
      DATA (CF(I, 21),I= 19, 24) /  -64,    8,  512,  -64,   80,    8/
C     1 T(5,3,1,4,2,6)
      DATA DENOM(22)/54/
      DATA (CF(I, 22),I=  1,  6) /   62,  -10,  -28,   62,   -1,  -10/
      DATA (CF(I, 22),I=  7, 12) /  -10,   -1,   -1,    8,    8,  -64/
      DATA (CF(I, 22),I= 13, 18) /   62,   71,  -10,   80,   -1,    8/
      DATA (CF(I, 22),I= 19, 24) /    8,   80,  -64,  512,    8,  -64/
C     1 T(5,3,4,1,2,6)
      DATA DENOM(23)/54/
      DATA (CF(I, 23),I=  1,  6) /   62,   71,  -10,   80,   -1,    8/
      DATA (CF(I, 23),I=  7, 12) /  -28,   62,   62,  -10,  -10,   -1/
      DATA (CF(I, 23),I= 13, 18) /   -1,    8,  -10,   -1,  -64,    8/
      DATA (CF(I, 23),I= 19, 24) /    8,  -64,   80,    8,  512,  -64/
C     1 T(5,4,1,3,2,6)
      DATA DENOM(24)/54/
      DATA (CF(I, 24),I=  1,  6) /  -28,   62,   62,  -10,  -10,   -1/
      DATA (CF(I, 24),I=  7, 12) /   62,   71,  -10,   80,   -1,    8/
      DATA (CF(I, 24),I= 13, 18) /  -10,   -1,   -1,    8,    8,  -64/
      DATA (CF(I, 24),I= 19, 24) /   80,    8,    8,  -64,  -64,  512/
C     1 T(5,4,3,1,2,6)
C     ----------
C     BEGIN CODE
C     ----------
      CALL VXXXXX(P(0,1),ZERO,NHEL(1),-1*IC(1),W(1,1))
      CALL OXXXXX(P(0,2),ZERO,NHEL(2),-1*IC(2),W(1,2))
      CALL VXXXXX(P(0,3),ZERO,NHEL(3),+1*IC(3),W(1,3))
      CALL VXXXXX(P(0,4),ZERO,NHEL(4),+1*IC(4),W(1,4))
      CALL VXXXXX(P(0,5),ZERO,NHEL(5),+1*IC(5),W(1,5))
      CALL IXXXXX(P(0,6),ZERO,NHEL(6),-1*IC(6),W(1,6))
      CALL FFV1_1(W(1,2),W(1,1),GC_11,ZERO,ZERO,W(1,7))
      CALL VVV1_1(W(1,3),W(1,4),GC_10,ZERO,ZERO,W(1,8))
      CALL FFV1_1(W(1,7),W(1,5),GC_11,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 1
      CALL FFV1_0(W(1,6),W(1,9),W(1,8),GC_11,AMP(1))
      CALL FFV1_3(W(1,6),W(1,7),GC_11,ZERO,ZERO,W(1,10))
C     Amplitude(s) for diagram number 2
      CALL VVV1_0(W(1,8),W(1,5),W(1,10),GC_10,AMP(2))
      CALL FFV1_2(W(1,6),W(1,5),GC_11,ZERO,ZERO,W(1,11))
C     Amplitude(s) for diagram number 3
      CALL FFV1_0(W(1,11),W(1,7),W(1,8),GC_11,AMP(3))
      CALL VVV1_1(W(1,3),W(1,5),GC_10,ZERO,ZERO,W(1,12))
      CALL FFV1_1(W(1,7),W(1,4),GC_11,ZERO,ZERO,W(1,13))
C     Amplitude(s) for diagram number 4
      CALL FFV1_0(W(1,6),W(1,13),W(1,12),GC_11,AMP(4))
C     Amplitude(s) for diagram number 5
      CALL VVV1_0(W(1,12),W(1,4),W(1,10),GC_10,AMP(5))
      CALL FFV1_2(W(1,6),W(1,4),GC_11,ZERO,ZERO,W(1,14))
C     Amplitude(s) for diagram number 6
      CALL FFV1_0(W(1,14),W(1,7),W(1,12),GC_11,AMP(6))
      CALL FFV1_2(W(1,6),W(1,3),GC_11,ZERO,ZERO,W(1,15))
C     Amplitude(s) for diagram number 7
      CALL FFV1_0(W(1,15),W(1,13),W(1,5),GC_11,AMP(7))
C     Amplitude(s) for diagram number 8
      CALL FFV1_0(W(1,15),W(1,9),W(1,4),GC_11,AMP(8))
      CALL VVV1_1(W(1,4),W(1,5),GC_10,ZERO,ZERO,W(1,16))
C     Amplitude(s) for diagram number 9
      CALL FFV1_0(W(1,15),W(1,7),W(1,16),GC_11,AMP(9))
      CALL FFV1_1(W(1,7),W(1,3),GC_11,ZERO,ZERO,W(1,17))
C     Amplitude(s) for diagram number 10
      CALL FFV1_0(W(1,6),W(1,17),W(1,16),GC_11,AMP(10))
C     Amplitude(s) for diagram number 11
      CALL VVV1_0(W(1,3),W(1,16),W(1,10),GC_10,AMP(11))
C     Amplitude(s) for diagram number 12
      CALL FFV1_0(W(1,14),W(1,17),W(1,5),GC_11,AMP(12))
C     Amplitude(s) for diagram number 13
      CALL FFV1_0(W(1,14),W(1,9),W(1,3),GC_11,AMP(13))
C     Amplitude(s) for diagram number 14
      CALL FFV1_0(W(1,11),W(1,17),W(1,4),GC_11,AMP(14))
C     Amplitude(s) for diagram number 15
      CALL FFV1_0(W(1,11),W(1,13),W(1,3),GC_11,AMP(15))
      CALL VVVV1_1(W(1,3),W(1,4),W(1,5),GC_12,ZERO,ZERO,W(1,13))
      CALL VVVV3_1(W(1,3),W(1,4),W(1,5),GC_12,ZERO,ZERO,W(1,17))
      CALL VVVV4_1(W(1,3),W(1,4),W(1,5),GC_12,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 16
      CALL FFV1_0(W(1,6),W(1,7),W(1,13),GC_11,AMP(16))
      CALL FFV1_0(W(1,6),W(1,7),W(1,17),GC_11,AMP(17))
      CALL FFV1_0(W(1,6),W(1,7),W(1,9),GC_11,AMP(18))
      CALL VVV1_1(W(1,1),W(1,3),GC_10,ZERO,ZERO,W(1,7))
      CALL FFV1_1(W(1,2),W(1,4),GC_11,ZERO,ZERO,W(1,10))
      CALL VVV1_1(W(1,7),W(1,5),GC_10,ZERO,ZERO,W(1,18))
C     Amplitude(s) for diagram number 17
      CALL FFV1_0(W(1,6),W(1,10),W(1,18),GC_11,AMP(19))
      CALL FFV1_2(W(1,6),W(1,7),GC_11,ZERO,ZERO,W(1,19))
C     Amplitude(s) for diagram number 18
      CALL FFV1_0(W(1,19),W(1,10),W(1,5),GC_11,AMP(20))
C     Amplitude(s) for diagram number 19
      CALL FFV1_0(W(1,11),W(1,10),W(1,7),GC_11,AMP(21))
      CALL FFV1_1(W(1,2),W(1,5),GC_11,ZERO,ZERO,W(1,20))
      CALL VVV1_1(W(1,7),W(1,4),GC_10,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 20
      CALL FFV1_0(W(1,6),W(1,20),W(1,21),GC_11,AMP(22))
C     Amplitude(s) for diagram number 21
      CALL FFV1_0(W(1,19),W(1,20),W(1,4),GC_11,AMP(23))
C     Amplitude(s) for diagram number 22
      CALL FFV1_0(W(1,14),W(1,20),W(1,7),GC_11,AMP(24))
      CALL FFV1_3(W(1,6),W(1,2),GC_11,ZERO,ZERO,W(1,22))
C     Amplitude(s) for diagram number 23
      CALL VVVV1_0(W(1,7),W(1,22),W(1,4),W(1,5),GC_12,AMP(25))
      CALL VVVV3_0(W(1,7),W(1,22),W(1,4),W(1,5),GC_12,AMP(26))
      CALL VVVV4_0(W(1,7),W(1,22),W(1,4),W(1,5),GC_12,AMP(27))
C     Amplitude(s) for diagram number 24
      CALL VVV1_0(W(1,22),W(1,5),W(1,21),GC_10,AMP(28))
C     Amplitude(s) for diagram number 25
      CALL VVV1_0(W(1,22),W(1,4),W(1,18),GC_10,AMP(29))
C     Amplitude(s) for diagram number 26
      CALL VVV1_0(W(1,7),W(1,22),W(1,16),GC_10,AMP(30))
      CALL FFV1_1(W(1,2),W(1,7),GC_11,ZERO,ZERO,W(1,23))
C     Amplitude(s) for diagram number 27
      CALL FFV1_0(W(1,6),W(1,23),W(1,16),GC_11,AMP(31))
C     Amplitude(s) for diagram number 28
      CALL FFV1_0(W(1,19),W(1,2),W(1,16),GC_11,AMP(32))
C     Amplitude(s) for diagram number 29
      CALL FFV1_0(W(1,14),W(1,23),W(1,5),GC_11,AMP(33))
C     Amplitude(s) for diagram number 30
      CALL FFV1_0(W(1,14),W(1,2),W(1,18),GC_11,AMP(34))
C     Amplitude(s) for diagram number 31
      CALL FFV1_0(W(1,11),W(1,23),W(1,4),GC_11,AMP(35))
C     Amplitude(s) for diagram number 32
      CALL FFV1_0(W(1,11),W(1,2),W(1,21),GC_11,AMP(36))
      CALL VVV1_1(W(1,1),W(1,4),GC_10,ZERO,ZERO,W(1,21))
      CALL FFV1_1(W(1,2),W(1,3),GC_11,ZERO,ZERO,W(1,23))
      CALL VVV1_1(W(1,21),W(1,5),GC_10,ZERO,ZERO,W(1,18))
C     Amplitude(s) for diagram number 33
      CALL FFV1_0(W(1,6),W(1,23),W(1,18),GC_11,AMP(37))
      CALL FFV1_2(W(1,6),W(1,21),GC_11,ZERO,ZERO,W(1,19))
C     Amplitude(s) for diagram number 34
      CALL FFV1_0(W(1,19),W(1,23),W(1,5),GC_11,AMP(38))
C     Amplitude(s) for diagram number 35
      CALL FFV1_0(W(1,11),W(1,23),W(1,21),GC_11,AMP(39))
      CALL VVV1_1(W(1,21),W(1,3),GC_10,ZERO,ZERO,W(1,7))
C     Amplitude(s) for diagram number 36
      CALL FFV1_0(W(1,6),W(1,20),W(1,7),GC_11,AMP(40))
C     Amplitude(s) for diagram number 37
      CALL FFV1_0(W(1,19),W(1,20),W(1,3),GC_11,AMP(41))
C     Amplitude(s) for diagram number 38
      CALL FFV1_0(W(1,15),W(1,20),W(1,21),GC_11,AMP(42))
C     Amplitude(s) for diagram number 39
      CALL VVVV1_0(W(1,21),W(1,22),W(1,3),W(1,5),GC_12,AMP(43))
      CALL VVVV3_0(W(1,21),W(1,22),W(1,3),W(1,5),GC_12,AMP(44))
      CALL VVVV4_0(W(1,21),W(1,22),W(1,3),W(1,5),GC_12,AMP(45))
C     Amplitude(s) for diagram number 40
      CALL VVV1_0(W(1,22),W(1,5),W(1,7),GC_10,AMP(46))
C     Amplitude(s) for diagram number 41
      CALL VVV1_0(W(1,22),W(1,3),W(1,18),GC_10,AMP(47))
C     Amplitude(s) for diagram number 42
      CALL VVV1_0(W(1,21),W(1,22),W(1,12),GC_10,AMP(48))
      CALL FFV1_1(W(1,2),W(1,21),GC_11,ZERO,ZERO,W(1,24))
C     Amplitude(s) for diagram number 43
      CALL FFV1_0(W(1,6),W(1,24),W(1,12),GC_11,AMP(49))
C     Amplitude(s) for diagram number 44
      CALL FFV1_0(W(1,19),W(1,2),W(1,12),GC_11,AMP(50))
C     Amplitude(s) for diagram number 45
      CALL FFV1_0(W(1,15),W(1,24),W(1,5),GC_11,AMP(51))
C     Amplitude(s) for diagram number 46
      CALL FFV1_0(W(1,15),W(1,2),W(1,18),GC_11,AMP(52))
C     Amplitude(s) for diagram number 47
      CALL FFV1_0(W(1,11),W(1,24),W(1,3),GC_11,AMP(53))
C     Amplitude(s) for diagram number 48
      CALL FFV1_0(W(1,11),W(1,2),W(1,7),GC_11,AMP(54))
      CALL VVV1_1(W(1,1),W(1,5),GC_10,ZERO,ZERO,W(1,7))
      CALL VVV1_1(W(1,7),W(1,4),GC_10,ZERO,ZERO,W(1,24))
C     Amplitude(s) for diagram number 49
      CALL FFV1_0(W(1,6),W(1,23),W(1,24),GC_11,AMP(55))
      CALL FFV1_2(W(1,6),W(1,7),GC_11,ZERO,ZERO,W(1,18))
C     Amplitude(s) for diagram number 50
      CALL FFV1_0(W(1,18),W(1,23),W(1,4),GC_11,AMP(56))
C     Amplitude(s) for diagram number 51
      CALL FFV1_0(W(1,14),W(1,23),W(1,7),GC_11,AMP(57))
      CALL VVV1_1(W(1,7),W(1,3),GC_10,ZERO,ZERO,W(1,19))
C     Amplitude(s) for diagram number 52
      CALL FFV1_0(W(1,6),W(1,10),W(1,19),GC_11,AMP(58))
C     Amplitude(s) for diagram number 53
      CALL FFV1_0(W(1,18),W(1,10),W(1,3),GC_11,AMP(59))
C     Amplitude(s) for diagram number 54
      CALL FFV1_0(W(1,15),W(1,10),W(1,7),GC_11,AMP(60))
C     Amplitude(s) for diagram number 55
      CALL VVVV1_0(W(1,7),W(1,22),W(1,3),W(1,4),GC_12,AMP(61))
      CALL VVVV3_0(W(1,7),W(1,22),W(1,3),W(1,4),GC_12,AMP(62))
      CALL VVVV4_0(W(1,7),W(1,22),W(1,3),W(1,4),GC_12,AMP(63))
C     Amplitude(s) for diagram number 56
      CALL VVV1_0(W(1,22),W(1,4),W(1,19),GC_10,AMP(64))
C     Amplitude(s) for diagram number 57
      CALL VVV1_0(W(1,22),W(1,3),W(1,24),GC_10,AMP(65))
C     Amplitude(s) for diagram number 58
      CALL VVV1_0(W(1,7),W(1,22),W(1,8),GC_10,AMP(66))
      CALL FFV1_1(W(1,2),W(1,7),GC_11,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 59
      CALL FFV1_0(W(1,6),W(1,21),W(1,8),GC_11,AMP(67))
C     Amplitude(s) for diagram number 60
      CALL FFV1_0(W(1,18),W(1,2),W(1,8),GC_11,AMP(68))
C     Amplitude(s) for diagram number 61
      CALL FFV1_0(W(1,15),W(1,21),W(1,4),GC_11,AMP(69))
C     Amplitude(s) for diagram number 62
      CALL FFV1_0(W(1,15),W(1,2),W(1,24),GC_11,AMP(70))
C     Amplitude(s) for diagram number 63
      CALL FFV1_0(W(1,14),W(1,21),W(1,3),GC_11,AMP(71))
C     Amplitude(s) for diagram number 64
      CALL FFV1_0(W(1,14),W(1,2),W(1,19),GC_11,AMP(72))
      CALL FFV1_2(W(1,6),W(1,1),GC_11,ZERO,ZERO,W(1,19))
      CALL FFV1_2(W(1,19),W(1,4),GC_11,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 65
      CALL FFV1_0(W(1,21),W(1,23),W(1,5),GC_11,AMP(73))
      CALL FFV1_2(W(1,19),W(1,5),GC_11,ZERO,ZERO,W(1,24))
C     Amplitude(s) for diagram number 66
      CALL FFV1_0(W(1,24),W(1,23),W(1,4),GC_11,AMP(74))
C     Amplitude(s) for diagram number 67
      CALL FFV1_0(W(1,19),W(1,23),W(1,16),GC_11,AMP(75))
      CALL FFV1_2(W(1,19),W(1,3),GC_11,ZERO,ZERO,W(1,18))
C     Amplitude(s) for diagram number 68
      CALL FFV1_0(W(1,18),W(1,10),W(1,5),GC_11,AMP(76))
C     Amplitude(s) for diagram number 69
      CALL FFV1_0(W(1,24),W(1,10),W(1,3),GC_11,AMP(77))
C     Amplitude(s) for diagram number 70
      CALL FFV1_0(W(1,19),W(1,10),W(1,12),GC_11,AMP(78))
C     Amplitude(s) for diagram number 71
      CALL FFV1_0(W(1,18),W(1,20),W(1,4),GC_11,AMP(79))
C     Amplitude(s) for diagram number 72
      CALL FFV1_0(W(1,21),W(1,20),W(1,3),GC_11,AMP(80))
C     Amplitude(s) for diagram number 73
      CALL FFV1_0(W(1,19),W(1,20),W(1,8),GC_11,AMP(81))
      CALL FFV1_3(W(1,19),W(1,2),GC_11,ZERO,ZERO,W(1,7))
C     Amplitude(s) for diagram number 74
      CALL VVV1_0(W(1,8),W(1,5),W(1,7),GC_10,AMP(82))
C     Amplitude(s) for diagram number 75
      CALL FFV1_0(W(1,24),W(1,2),W(1,8),GC_11,AMP(83))
C     Amplitude(s) for diagram number 76
      CALL VVV1_0(W(1,12),W(1,4),W(1,7),GC_10,AMP(84))
C     Amplitude(s) for diagram number 77
      CALL FFV1_0(W(1,21),W(1,2),W(1,12),GC_11,AMP(85))
C     Amplitude(s) for diagram number 78
      CALL VVV1_0(W(1,3),W(1,16),W(1,7),GC_10,AMP(86))
C     Amplitude(s) for diagram number 79
      CALL FFV1_0(W(1,18),W(1,2),W(1,16),GC_11,AMP(87))
C     Amplitude(s) for diagram number 80
      CALL FFV1_0(W(1,19),W(1,2),W(1,13),GC_11,AMP(88))
      CALL FFV1_0(W(1,19),W(1,2),W(1,17),GC_11,AMP(89))
      CALL FFV1_0(W(1,19),W(1,2),W(1,9),GC_11,AMP(90))
      CALL FFV1_1(W(1,23),W(1,1),GC_11,ZERO,ZERO,W(1,19))
C     Amplitude(s) for diagram number 81
      CALL FFV1_0(W(1,6),W(1,19),W(1,16),GC_11,AMP(91))
      CALL VVV1_1(W(1,1),W(1,16),GC_10,ZERO,ZERO,W(1,18))
C     Amplitude(s) for diagram number 82
      CALL FFV1_0(W(1,6),W(1,23),W(1,18),GC_11,AMP(92))
C     Amplitude(s) for diagram number 83
      CALL FFV1_0(W(1,14),W(1,19),W(1,5),GC_11,AMP(93))
      CALL FFV1_2(W(1,14),W(1,1),GC_11,ZERO,ZERO,W(1,7))
C     Amplitude(s) for diagram number 84
      CALL FFV1_0(W(1,7),W(1,23),W(1,5),GC_11,AMP(94))
C     Amplitude(s) for diagram number 85
      CALL FFV1_0(W(1,11),W(1,19),W(1,4),GC_11,AMP(95))
      CALL FFV1_2(W(1,11),W(1,1),GC_11,ZERO,ZERO,W(1,19))
C     Amplitude(s) for diagram number 86
      CALL FFV1_0(W(1,19),W(1,23),W(1,4),GC_11,AMP(96))
      CALL FFV1_1(W(1,10),W(1,1),GC_11,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 87
      CALL FFV1_0(W(1,6),W(1,21),W(1,12),GC_11,AMP(97))
      CALL VVV1_1(W(1,1),W(1,12),GC_10,ZERO,ZERO,W(1,24))
C     Amplitude(s) for diagram number 88
      CALL FFV1_0(W(1,6),W(1,10),W(1,24),GC_11,AMP(98))
C     Amplitude(s) for diagram number 89
      CALL FFV1_0(W(1,15),W(1,21),W(1,5),GC_11,AMP(99))
      CALL FFV1_2(W(1,15),W(1,1),GC_11,ZERO,ZERO,W(1,25))
C     Amplitude(s) for diagram number 90
      CALL FFV1_0(W(1,25),W(1,10),W(1,5),GC_11,AMP(100))
C     Amplitude(s) for diagram number 91
      CALL FFV1_0(W(1,11),W(1,21),W(1,3),GC_11,AMP(101))
C     Amplitude(s) for diagram number 92
      CALL FFV1_0(W(1,19),W(1,10),W(1,3),GC_11,AMP(102))
      CALL FFV1_1(W(1,20),W(1,1),GC_11,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 93
      CALL FFV1_0(W(1,6),W(1,21),W(1,8),GC_11,AMP(103))
      CALL VVV1_1(W(1,1),W(1,8),GC_10,ZERO,ZERO,W(1,26))
C     Amplitude(s) for diagram number 94
      CALL FFV1_0(W(1,6),W(1,20),W(1,26),GC_11,AMP(104))
C     Amplitude(s) for diagram number 95
      CALL FFV1_0(W(1,15),W(1,21),W(1,4),GC_11,AMP(105))
C     Amplitude(s) for diagram number 96
      CALL FFV1_0(W(1,25),W(1,20),W(1,4),GC_11,AMP(106))
C     Amplitude(s) for diagram number 97
      CALL FFV1_0(W(1,14),W(1,21),W(1,3),GC_11,AMP(107))
C     Amplitude(s) for diagram number 98
      CALL FFV1_0(W(1,7),W(1,20),W(1,3),GC_11,AMP(108))
C     Amplitude(s) for diagram number 99
      CALL VVVV1_0(W(1,1),W(1,22),W(1,8),W(1,5),GC_12,AMP(109))
      CALL VVVV3_0(W(1,1),W(1,22),W(1,8),W(1,5),GC_12,AMP(110))
      CALL VVVV4_0(W(1,1),W(1,22),W(1,8),W(1,5),GC_12,AMP(111))
      CALL VVV1_1(W(1,1),W(1,22),GC_10,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 100
      CALL VVV1_0(W(1,8),W(1,5),W(1,21),GC_10,AMP(112))
C     Amplitude(s) for diagram number 101
      CALL VVV1_0(W(1,22),W(1,5),W(1,26),GC_10,AMP(113))
C     Amplitude(s) for diagram number 102
      CALL VVVV1_0(W(1,1),W(1,22),W(1,12),W(1,4),GC_12,AMP(114))
      CALL VVVV3_0(W(1,1),W(1,22),W(1,12),W(1,4),GC_12,AMP(115))
      CALL VVVV4_0(W(1,1),W(1,22),W(1,12),W(1,4),GC_12,AMP(116))
C     Amplitude(s) for diagram number 103
      CALL VVV1_0(W(1,12),W(1,4),W(1,21),GC_10,AMP(117))
C     Amplitude(s) for diagram number 104
      CALL VVV1_0(W(1,22),W(1,4),W(1,24),GC_10,AMP(118))
C     Amplitude(s) for diagram number 105
      CALL VVVV1_0(W(1,1),W(1,22),W(1,3),W(1,16),GC_12,AMP(119))
      CALL VVVV3_0(W(1,1),W(1,22),W(1,3),W(1,16),GC_12,AMP(120))
      CALL VVVV4_0(W(1,1),W(1,22),W(1,3),W(1,16),GC_12,AMP(121))
C     Amplitude(s) for diagram number 106
      CALL VVV1_0(W(1,3),W(1,16),W(1,21),GC_10,AMP(122))
C     Amplitude(s) for diagram number 107
      CALL VVV1_0(W(1,22),W(1,3),W(1,18),GC_10,AMP(123))
C     Amplitude(s) for diagram number 108
      CALL VVV1_0(W(1,1),W(1,22),W(1,13),GC_10,AMP(124))
      CALL VVV1_0(W(1,1),W(1,22),W(1,17),GC_10,AMP(125))
      CALL VVV1_0(W(1,1),W(1,22),W(1,9),GC_10,AMP(126))
C     Amplitude(s) for diagram number 109
      CALL FFV1_0(W(1,11),W(1,2),W(1,26),GC_11,AMP(127))
C     Amplitude(s) for diagram number 110
      CALL FFV1_0(W(1,19),W(1,2),W(1,8),GC_11,AMP(128))
C     Amplitude(s) for diagram number 111
      CALL FFV1_0(W(1,14),W(1,2),W(1,24),GC_11,AMP(129))
C     Amplitude(s) for diagram number 112
      CALL FFV1_0(W(1,7),W(1,2),W(1,12),GC_11,AMP(130))
C     Amplitude(s) for diagram number 113
      CALL FFV1_0(W(1,25),W(1,2),W(1,16),GC_11,AMP(131))
C     Amplitude(s) for diagram number 114
      CALL FFV1_0(W(1,15),W(1,2),W(1,18),GC_11,AMP(132))
      CALL VVVV1_1(W(1,1),W(1,3),W(1,4),GC_12,ZERO,ZERO,W(1,18))
      CALL VVVV3_1(W(1,1),W(1,3),W(1,4),GC_12,ZERO,ZERO,W(1,25))
      CALL VVVV4_1(W(1,1),W(1,3),W(1,4),GC_12,ZERO,ZERO,W(1,16))
C     Amplitude(s) for diagram number 115
      CALL FFV1_0(W(1,6),W(1,20),W(1,18),GC_11,AMP(133))
      CALL FFV1_0(W(1,6),W(1,20),W(1,25),GC_11,AMP(134))
      CALL FFV1_0(W(1,6),W(1,20),W(1,16),GC_11,AMP(135))
C     Amplitude(s) for diagram number 116
      CALL VVV1_0(W(1,18),W(1,22),W(1,5),GC_10,AMP(136))
      CALL VVV1_0(W(1,25),W(1,22),W(1,5),GC_10,AMP(137))
      CALL VVV1_0(W(1,16),W(1,22),W(1,5),GC_10,AMP(138))
C     Amplitude(s) for diagram number 117
      CALL FFV1_0(W(1,11),W(1,2),W(1,18),GC_11,AMP(139))
      CALL FFV1_0(W(1,11),W(1,2),W(1,25),GC_11,AMP(140))
      CALL FFV1_0(W(1,11),W(1,2),W(1,16),GC_11,AMP(141))
      CALL VVVV1_1(W(1,1),W(1,3),W(1,5),GC_12,ZERO,ZERO,W(1,16))
      CALL VVVV3_1(W(1,1),W(1,3),W(1,5),GC_12,ZERO,ZERO,W(1,11))
      CALL VVVV4_1(W(1,1),W(1,3),W(1,5),GC_12,ZERO,ZERO,W(1,25))
C     Amplitude(s) for diagram number 118
      CALL FFV1_0(W(1,6),W(1,10),W(1,16),GC_11,AMP(142))
      CALL FFV1_0(W(1,6),W(1,10),W(1,11),GC_11,AMP(143))
      CALL FFV1_0(W(1,6),W(1,10),W(1,25),GC_11,AMP(144))
C     Amplitude(s) for diagram number 119
      CALL VVV1_0(W(1,16),W(1,22),W(1,4),GC_10,AMP(145))
      CALL VVV1_0(W(1,11),W(1,22),W(1,4),GC_10,AMP(146))
      CALL VVV1_0(W(1,25),W(1,22),W(1,4),GC_10,AMP(147))
C     Amplitude(s) for diagram number 120
      CALL FFV1_0(W(1,14),W(1,2),W(1,16),GC_11,AMP(148))
      CALL FFV1_0(W(1,14),W(1,2),W(1,11),GC_11,AMP(149))
      CALL FFV1_0(W(1,14),W(1,2),W(1,25),GC_11,AMP(150))
      CALL VVVV1_1(W(1,1),W(1,4),W(1,5),GC_12,ZERO,ZERO,W(1,25))
      CALL VVVV3_1(W(1,1),W(1,4),W(1,5),GC_12,ZERO,ZERO,W(1,14))
      CALL VVVV4_1(W(1,1),W(1,4),W(1,5),GC_12,ZERO,ZERO,W(1,11))
C     Amplitude(s) for diagram number 121
      CALL FFV1_0(W(1,6),W(1,23),W(1,25),GC_11,AMP(151))
      CALL FFV1_0(W(1,6),W(1,23),W(1,14),GC_11,AMP(152))
      CALL FFV1_0(W(1,6),W(1,23),W(1,11),GC_11,AMP(153))
C     Amplitude(s) for diagram number 122
      CALL VVV1_0(W(1,25),W(1,22),W(1,3),GC_10,AMP(154))
      CALL VVV1_0(W(1,14),W(1,22),W(1,3),GC_10,AMP(155))
      CALL VVV1_0(W(1,11),W(1,22),W(1,3),GC_10,AMP(156))
C     Amplitude(s) for diagram number 123
      CALL FFV1_0(W(1,15),W(1,2),W(1,25),GC_11,AMP(157))
      CALL FFV1_0(W(1,15),W(1,2),W(1,14),GC_11,AMP(158))
      CALL FFV1_0(W(1,15),W(1,2),W(1,11),GC_11,AMP(159))
      JAMP(1)=+AMP(2)+IMAG1*AMP(3)+IMAG1*AMP(10)+AMP(11)-AMP(14)
     $ -AMP(18)+AMP(16)+IMAG1*AMP(25)+IMAG1*AMP(26)+IMAG1*AMP(28)
     $ +IMAG1*AMP(30)+AMP(31)+IMAG1*AMP(35)+AMP(36)+IMAG1*AMP(109)
     $ +IMAG1*AMP(110)+IMAG1*AMP(112)+IMAG1*AMP(113)+IMAG1*AMP(119)
     $ +IMAG1*AMP(120)+IMAG1*AMP(122)-IMAG1*AMP(126)+IMAG1*AMP(124)
     $ +AMP(127)+IMAG1*AMP(136)-IMAG1*AMP(138)-AMP(141)+AMP(139)
      JAMP(2)=+AMP(5)+IMAG1*AMP(6)-IMAG1*AMP(10)-AMP(11)-AMP(12)
     $ -AMP(17)-AMP(16)-IMAG1*AMP(25)+IMAG1*AMP(27)+IMAG1*AMP(29)
     $ -IMAG1*AMP(30)-AMP(31)+IMAG1*AMP(33)+AMP(34)+IMAG1*AMP(114)
     $ +IMAG1*AMP(115)+IMAG1*AMP(117)+IMAG1*AMP(118)-IMAG1*AMP(119)
     $ -IMAG1*AMP(120)-IMAG1*AMP(122)-IMAG1*AMP(125)-IMAG1*AMP(124)
     $ +AMP(129)+IMAG1*AMP(145)-IMAG1*AMP(147)-AMP(150)+AMP(148)
      JAMP(3)=-AMP(2)-IMAG1*AMP(3)+IMAG1*AMP(4)-AMP(5)-AMP(15)+AMP(18)
     $ +AMP(17)+IMAG1*AMP(43)+IMAG1*AMP(44)+IMAG1*AMP(46)+IMAG1
     $ *AMP(48)+AMP(49)+IMAG1*AMP(53)+AMP(54)-IMAG1*AMP(109)-IMAG1
     $ *AMP(110)-IMAG1*AMP(112)-IMAG1*AMP(113)-IMAG1*AMP(114)
     $ +IMAG1*AMP(116)-IMAG1*AMP(117)+IMAG1*AMP(126)+IMAG1*AMP(125)
     $ -AMP(127)-IMAG1*AMP(137)-IMAG1*AMP(136)-AMP(140)-AMP(139)
      JAMP(4)=-IMAG1*AMP(4)+AMP(5)-AMP(7)+IMAG1*AMP(9)-AMP(11)-AMP(17)
     $ -AMP(16)-IMAG1*AMP(43)+IMAG1*AMP(45)+IMAG1*AMP(47)-IMAG1
     $ *AMP(48)-AMP(49)+IMAG1*AMP(51)+AMP(52)+IMAG1*AMP(114)-IMAG1
     $ *AMP(116)+IMAG1*AMP(117)-IMAG1*AMP(119)+IMAG1*AMP(121)
     $ -IMAG1*AMP(122)+IMAG1*AMP(123)-IMAG1*AMP(125)-IMAG1*AMP(124)
     $ +AMP(132)+IMAG1*AMP(154)-IMAG1*AMP(156)-AMP(159)+AMP(157)
      JAMP(5)=+IMAG1*AMP(1)-AMP(2)-AMP(5)-IMAG1*AMP(6)-AMP(13)+AMP(18)
     $ +AMP(17)+IMAG1*AMP(61)+IMAG1*AMP(62)+IMAG1*AMP(64)+IMAG1
     $ *AMP(66)+AMP(67)+IMAG1*AMP(71)+AMP(72)-IMAG1*AMP(109)+IMAG1
     $ *AMP(111)-IMAG1*AMP(112)-IMAG1*AMP(114)-IMAG1*AMP(115)
     $ -IMAG1*AMP(117)-IMAG1*AMP(118)+IMAG1*AMP(126)+IMAG1*AMP(125)
     $ -AMP(129)-IMAG1*AMP(146)-IMAG1*AMP(145)-AMP(149)-AMP(148)
      JAMP(6)=-IMAG1*AMP(1)+AMP(2)-AMP(8)-IMAG1*AMP(9)+AMP(11)-AMP(18)
     $ +AMP(16)-IMAG1*AMP(61)+IMAG1*AMP(63)+IMAG1*AMP(65)-IMAG1
     $ *AMP(66)-AMP(67)+IMAG1*AMP(69)+AMP(70)+IMAG1*AMP(109)-IMAG1
     $ *AMP(111)+IMAG1*AMP(112)+IMAG1*AMP(119)-IMAG1*AMP(121)
     $ +IMAG1*AMP(122)-IMAG1*AMP(123)-IMAG1*AMP(126)+IMAG1*AMP(124)
     $ -AMP(132)-IMAG1*AMP(155)-IMAG1*AMP(154)-AMP(158)-AMP(157)
      JAMP(7)=-IMAG1*AMP(25)-IMAG1*AMP(26)-IMAG1*AMP(28)-IMAG1*AMP(30)
     $ -AMP(31)-IMAG1*AMP(35)-AMP(36)+AMP(37)+IMAG1*AMP(39)-IMAG1
     $ *AMP(44)-IMAG1*AMP(45)-IMAG1*AMP(46)-IMAG1*AMP(47)-AMP(54)
     $ +IMAG1*AMP(91)+AMP(92)-AMP(95)-IMAG1*AMP(120)-IMAG1*AMP(121)
     $ -IMAG1*AMP(123)+IMAG1*AMP(137)+IMAG1*AMP(138)+AMP(141)
     $ +AMP(140)-AMP(153)+AMP(151)-IMAG1*AMP(154)+IMAG1*AMP(156)
      JAMP(8)=+IMAG1*AMP(25)-IMAG1*AMP(27)-IMAG1*AMP(29)+IMAG1*AMP(30)
     $ +AMP(31)-IMAG1*AMP(33)-AMP(34)+AMP(55)+IMAG1*AMP(57)-IMAG1
     $ *AMP(62)-IMAG1*AMP(63)-IMAG1*AMP(64)-IMAG1*AMP(65)-AMP(72)
     $ -IMAG1*AMP(91)-AMP(92)-AMP(93)+IMAG1*AMP(120)+IMAG1*AMP(121)
     $ +IMAG1*AMP(123)+IMAG1*AMP(146)+IMAG1*AMP(147)+AMP(150)
     $ +AMP(149)-AMP(152)-AMP(151)+IMAG1*AMP(155)+IMAG1*AMP(154)
      JAMP(9)=-AMP(37)-IMAG1*AMP(39)+IMAG1*AMP(44)+IMAG1*AMP(45)
     $ +IMAG1*AMP(46)+IMAG1*AMP(47)+AMP(54)-AMP(55)+IMAG1*AMP(56)
     $ -IMAG1*AMP(61)+IMAG1*AMP(63)+IMAG1*AMP(65)-IMAG1*AMP(66)
     $ +AMP(68)-AMP(96)-IMAG1*AMP(110)-IMAG1*AMP(111)-IMAG1*AMP(113)
     $ -AMP(127)+IMAG1*AMP(128)-IMAG1*AMP(137)-IMAG1*AMP(136)-AMP(140)
     $ -AMP(139)+AMP(153)+AMP(152)-IMAG1*AMP(155)-IMAG1*AMP(156)
      JAMP(10)=+AMP(55)-IMAG1*AMP(56)+IMAG1*AMP(61)-IMAG1*AMP(63)
     $ -IMAG1*AMP(65)+IMAG1*AMP(66)-AMP(68)-AMP(74)+IMAG1*AMP(75)
     $ +AMP(82)+IMAG1*AMP(83)+AMP(86)-AMP(90)+AMP(88)-AMP(92)
     $ -IMAG1*AMP(109)+IMAG1*AMP(111)-IMAG1*AMP(112)-IMAG1*AMP(119)
     $ +IMAG1*AMP(121)-IMAG1*AMP(122)+IMAG1*AMP(123)+IMAG1*AMP(126)
     $ -IMAG1*AMP(124)-AMP(152)-AMP(151)+IMAG1*AMP(155)+IMAG1*AMP(154)
      JAMP(11)=-AMP(37)+IMAG1*AMP(38)-IMAG1*AMP(43)+IMAG1*AMP(45)
     $ +IMAG1*AMP(47)-IMAG1*AMP(48)+AMP(50)-AMP(55)-IMAG1*AMP(57)
     $ +IMAG1*AMP(62)+IMAG1*AMP(63)+IMAG1*AMP(64)+IMAG1*AMP(65)
     $ +AMP(72)-AMP(94)-IMAG1*AMP(115)-IMAG1*AMP(116)-IMAG1*AMP(118)
     $ -AMP(129)+IMAG1*AMP(130)-IMAG1*AMP(146)-IMAG1*AMP(145)-AMP(149)
     $ -AMP(148)+AMP(153)+AMP(152)-IMAG1*AMP(155)-IMAG1*AMP(156)
      JAMP(12)=+AMP(37)-IMAG1*AMP(38)+IMAG1*AMP(43)-IMAG1*AMP(45)
     $ -IMAG1*AMP(47)+IMAG1*AMP(48)-AMP(50)-AMP(73)-IMAG1*AMP(75)
     $ +AMP(84)+IMAG1*AMP(85)-AMP(86)-AMP(89)-AMP(88)+AMP(92)
     $ -IMAG1*AMP(114)+IMAG1*AMP(116)-IMAG1*AMP(117)+IMAG1*AMP(119)
     $ -IMAG1*AMP(121)+IMAG1*AMP(122)-IMAG1*AMP(123)+IMAG1*AMP(125)
     $ +IMAG1*AMP(124)-AMP(153)+AMP(151)-IMAG1*AMP(154)+IMAG1*AMP(156)
      JAMP(13)=+AMP(19)+IMAG1*AMP(21)-IMAG1*AMP(26)-IMAG1*AMP(27)
     $ -IMAG1*AMP(28)-IMAG1*AMP(29)-AMP(36)-IMAG1*AMP(43)-IMAG1
     $ *AMP(44)-IMAG1*AMP(46)-IMAG1*AMP(48)-AMP(49)-IMAG1*AMP(53)
     $ -AMP(54)+IMAG1*AMP(97)+AMP(98)-AMP(101)-IMAG1*AMP(115)
     $ -IMAG1*AMP(116)-IMAG1*AMP(118)+IMAG1*AMP(137)+IMAG1*AMP(138)
     $ +AMP(141)+AMP(140)-AMP(144)+AMP(142)-IMAG1*AMP(145)+IMAG1
     $ *AMP(147)
      JAMP(14)=+IMAG1*AMP(43)-IMAG1*AMP(45)-IMAG1*AMP(47)+IMAG1
     $ *AMP(48)+AMP(49)-IMAG1*AMP(51)-AMP(52)+AMP(58)+IMAG1*AMP(60)
     $ -IMAG1*AMP(62)-IMAG1*AMP(63)-IMAG1*AMP(64)-IMAG1*AMP(65)
     $ -AMP(70)-IMAG1*AMP(97)-AMP(98)-AMP(99)+IMAG1*AMP(115)+IMAG1
     $ *AMP(116)+IMAG1*AMP(118)-AMP(143)-AMP(142)+IMAG1*AMP(146)
     $ +IMAG1*AMP(145)+IMAG1*AMP(155)+IMAG1*AMP(156)+AMP(159)+AMP(158)
      JAMP(15)=-AMP(19)-IMAG1*AMP(21)+IMAG1*AMP(26)+IMAG1*AMP(27)
     $ +IMAG1*AMP(28)+IMAG1*AMP(29)+AMP(36)-AMP(58)+IMAG1*AMP(59)
     $ +IMAG1*AMP(61)+IMAG1*AMP(62)+IMAG1*AMP(64)+IMAG1*AMP(66)
     $ -AMP(68)-AMP(102)+IMAG1*AMP(110)+IMAG1*AMP(111)+IMAG1*AMP(113)
     $ +AMP(127)-IMAG1*AMP(128)+IMAG1*AMP(136)-IMAG1*AMP(138)-AMP(141)
     $ +AMP(139)+AMP(144)+AMP(143)-IMAG1*AMP(146)-IMAG1*AMP(147)
      JAMP(16)=+AMP(58)-IMAG1*AMP(59)-IMAG1*AMP(61)-IMAG1*AMP(62)
     $ -IMAG1*AMP(64)-IMAG1*AMP(66)+AMP(68)-AMP(77)+IMAG1*AMP(78)
     $ -AMP(82)-IMAG1*AMP(83)-AMP(84)+AMP(90)+AMP(89)-AMP(98)
     $ +IMAG1*AMP(109)-IMAG1*AMP(111)+IMAG1*AMP(112)+IMAG1*AMP(114)
     $ +IMAG1*AMP(115)+IMAG1*AMP(117)+IMAG1*AMP(118)-IMAG1*AMP(126)
     $ -IMAG1*AMP(125)-AMP(143)-AMP(142)+IMAG1*AMP(146)+IMAG1*AMP(145)
      JAMP(17)=-AMP(19)+IMAG1*AMP(20)-IMAG1*AMP(25)+IMAG1*AMP(27)
     $ +IMAG1*AMP(29)-IMAG1*AMP(30)+AMP(32)-AMP(58)-IMAG1*AMP(60)
     $ +IMAG1*AMP(62)+IMAG1*AMP(63)+IMAG1*AMP(64)+IMAG1*AMP(65)
     $ +AMP(70)-AMP(100)-IMAG1*AMP(120)-IMAG1*AMP(121)-IMAG1*AMP(123)
     $ +IMAG1*AMP(131)-AMP(132)+AMP(144)+AMP(143)-IMAG1*AMP(146)
     $ -IMAG1*AMP(147)-IMAG1*AMP(155)-IMAG1*AMP(154)-AMP(158)-AMP(157)
      JAMP(18)=+AMP(19)-IMAG1*AMP(20)+IMAG1*AMP(25)-IMAG1*AMP(27)
     $ -IMAG1*AMP(29)+IMAG1*AMP(30)-AMP(32)-AMP(76)-IMAG1*AMP(78)
     $ +AMP(84)-AMP(86)+IMAG1*AMP(87)-AMP(89)-AMP(88)+AMP(98)
     $ -IMAG1*AMP(114)-IMAG1*AMP(115)-IMAG1*AMP(117)-IMAG1*AMP(118)
     $ +IMAG1*AMP(119)+IMAG1*AMP(120)+IMAG1*AMP(122)+IMAG1*AMP(125)
     $ +IMAG1*AMP(124)-AMP(144)+AMP(142)-IMAG1*AMP(145)+IMAG1*AMP(147)
      JAMP(19)=+AMP(22)+IMAG1*AMP(24)-IMAG1*AMP(26)-IMAG1*AMP(27)
     $ -IMAG1*AMP(28)-IMAG1*AMP(29)-AMP(34)-IMAG1*AMP(61)-IMAG1
     $ *AMP(62)-IMAG1*AMP(64)-IMAG1*AMP(66)-AMP(67)-IMAG1*AMP(71)
     $ -AMP(72)+IMAG1*AMP(103)+AMP(104)-AMP(107)-IMAG1*AMP(110)
     $ -IMAG1*AMP(111)-IMAG1*AMP(113)-AMP(135)+AMP(133)-IMAG1*AMP(136)
     $ +IMAG1*AMP(138)+IMAG1*AMP(146)+IMAG1*AMP(147)+AMP(150)+AMP(149)
      JAMP(20)=+AMP(40)+IMAG1*AMP(42)-IMAG1*AMP(44)-IMAG1*AMP(45)
     $ -IMAG1*AMP(46)-IMAG1*AMP(47)-AMP(52)+IMAG1*AMP(61)-IMAG1
     $ *AMP(63)-IMAG1*AMP(65)+IMAG1*AMP(66)+AMP(67)-IMAG1*AMP(69)
     $ -AMP(70)-IMAG1*AMP(103)-AMP(104)-AMP(105)+IMAG1*AMP(110)
     $ +IMAG1*AMP(111)+IMAG1*AMP(113)-AMP(134)-AMP(133)+IMAG1*AMP(137)
     $ +IMAG1*AMP(136)+IMAG1*AMP(155)+IMAG1*AMP(156)+AMP(159)+AMP(158)
      JAMP(21)=-AMP(22)-IMAG1*AMP(24)+IMAG1*AMP(26)+IMAG1*AMP(27)
     $ +IMAG1*AMP(28)+IMAG1*AMP(29)+AMP(34)-AMP(40)+IMAG1*AMP(41)
     $ +IMAG1*AMP(43)+IMAG1*AMP(44)+IMAG1*AMP(46)+IMAG1*AMP(48)
     $ -AMP(50)-AMP(108)+IMAG1*AMP(115)+IMAG1*AMP(116)+IMAG1*AMP(118)
     $ +AMP(129)-IMAG1*AMP(130)+AMP(135)+AMP(134)-IMAG1*AMP(137)
     $ -IMAG1*AMP(138)+IMAG1*AMP(145)-IMAG1*AMP(147)-AMP(150)+AMP(148)
      JAMP(22)=+AMP(40)-IMAG1*AMP(41)-IMAG1*AMP(43)-IMAG1*AMP(44)
     $ -IMAG1*AMP(46)-IMAG1*AMP(48)+AMP(50)-AMP(80)+IMAG1*AMP(81)
     $ -AMP(82)-AMP(84)-IMAG1*AMP(85)+AMP(90)+AMP(89)-AMP(104)
     $ +IMAG1*AMP(109)+IMAG1*AMP(110)+IMAG1*AMP(112)+IMAG1*AMP(113)
     $ +IMAG1*AMP(114)-IMAG1*AMP(116)+IMAG1*AMP(117)-IMAG1*AMP(126)
     $ -IMAG1*AMP(125)-AMP(134)-AMP(133)+IMAG1*AMP(137)+IMAG1*AMP(136)
      JAMP(23)=-AMP(22)+IMAG1*AMP(23)+IMAG1*AMP(25)+IMAG1*AMP(26)
     $ +IMAG1*AMP(28)+IMAG1*AMP(30)-AMP(32)-AMP(40)-IMAG1*AMP(42)
     $ +IMAG1*AMP(44)+IMAG1*AMP(45)+IMAG1*AMP(46)+IMAG1*AMP(47)
     $ +AMP(52)-AMP(106)+IMAG1*AMP(120)+IMAG1*AMP(121)+IMAG1*AMP(123)
     $ -IMAG1*AMP(131)+AMP(132)+AMP(135)+AMP(134)-IMAG1*AMP(137)
     $ -IMAG1*AMP(138)+IMAG1*AMP(154)-IMAG1*AMP(156)-AMP(159)+AMP(157)
      JAMP(24)=+AMP(22)-IMAG1*AMP(23)-IMAG1*AMP(25)-IMAG1*AMP(26)
     $ -IMAG1*AMP(28)-IMAG1*AMP(30)+AMP(32)-AMP(79)-IMAG1*AMP(81)
     $ +AMP(82)+AMP(86)-IMAG1*AMP(87)-AMP(90)+AMP(88)+AMP(104)
     $ -IMAG1*AMP(109)-IMAG1*AMP(110)-IMAG1*AMP(112)-IMAG1*AMP(113)
     $ -IMAG1*AMP(119)-IMAG1*AMP(120)-IMAG1*AMP(122)+IMAG1*AMP(126)
     $ -IMAG1*AMP(124)-AMP(135)+AMP(133)-IMAG1*AMP(136)+IMAG1*AMP(138)
      MATRIX2 = 0.D0
      DO I = 1, NCOLOR
        ZTEMP = (0.D0,0.D0)
        DO J = 1, NCOLOR
          ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
        ENDDO
        MATRIX2=MATRIX2+ZTEMP*DCONJG(JAMP(I))/DENOM(I)
      ENDDO
      AMP2(28)=AMP2(28)+AMP(32)*DCONJG(AMP(32))
      AMP2(27)=AMP2(27)+AMP(31)*DCONJG(AMP(31))
      AMP2(26)=AMP2(26)+AMP(30)*DCONJG(AMP(30))
      AMP2(30)=AMP2(30)+AMP(34)*DCONJG(AMP(34))
      AMP2(29)=AMP2(29)+AMP(33)*DCONJG(AMP(33))
      AMP2(22)=AMP2(22)+AMP(24)*DCONJG(AMP(24))
      AMP2(17)=AMP2(17)+AMP(19)*DCONJG(AMP(19))
      AMP2(18)=AMP2(18)+AMP(20)*DCONJG(AMP(20))
      AMP2(19)=AMP2(19)+AMP(21)*DCONJG(AMP(21))
      AMP2(32)=AMP2(32)+AMP(36)*DCONJG(AMP(36))
      AMP2(31)=AMP2(31)+AMP(35)*DCONJG(AMP(35))
      AMP2(20)=AMP2(20)+AMP(22)*DCONJG(AMP(22))
      AMP2(21)=AMP2(21)+AMP(23)*DCONJG(AMP(23))
      AMP2(24)=AMP2(24)+AMP(28)*DCONJG(AMP(28))
      AMP2(25)=AMP2(25)+AMP(29)*DCONJG(AMP(29))
      AMP2(44)=AMP2(44)+AMP(50)*DCONJG(AMP(50))
      AMP2(43)=AMP2(43)+AMP(49)*DCONJG(AMP(49))
      AMP2(42)=AMP2(42)+AMP(48)*DCONJG(AMP(48))
      AMP2(46)=AMP2(46)+AMP(52)*DCONJG(AMP(52))
      AMP2(45)=AMP2(45)+AMP(51)*DCONJG(AMP(51))
      AMP2(38)=AMP2(38)+AMP(42)*DCONJG(AMP(42))
      AMP2(33)=AMP2(33)+AMP(37)*DCONJG(AMP(37))
      AMP2(34)=AMP2(34)+AMP(38)*DCONJG(AMP(38))
      AMP2(35)=AMP2(35)+AMP(39)*DCONJG(AMP(39))
      AMP2(48)=AMP2(48)+AMP(54)*DCONJG(AMP(54))
      AMP2(47)=AMP2(47)+AMP(53)*DCONJG(AMP(53))
      AMP2(36)=AMP2(36)+AMP(40)*DCONJG(AMP(40))
      AMP2(37)=AMP2(37)+AMP(41)*DCONJG(AMP(41))
      AMP2(40)=AMP2(40)+AMP(46)*DCONJG(AMP(46))
      AMP2(41)=AMP2(41)+AMP(47)*DCONJG(AMP(47))
      AMP2(60)=AMP2(60)+AMP(68)*DCONJG(AMP(68))
      AMP2(59)=AMP2(59)+AMP(67)*DCONJG(AMP(67))
      AMP2(58)=AMP2(58)+AMP(66)*DCONJG(AMP(66))
      AMP2(62)=AMP2(62)+AMP(70)*DCONJG(AMP(70))
      AMP2(61)=AMP2(61)+AMP(69)*DCONJG(AMP(69))
      AMP2(54)=AMP2(54)+AMP(60)*DCONJG(AMP(60))
      AMP2(49)=AMP2(49)+AMP(55)*DCONJG(AMP(55))
      AMP2(50)=AMP2(50)+AMP(56)*DCONJG(AMP(56))
      AMP2(51)=AMP2(51)+AMP(57)*DCONJG(AMP(57))
      AMP2(64)=AMP2(64)+AMP(72)*DCONJG(AMP(72))
      AMP2(63)=AMP2(63)+AMP(71)*DCONJG(AMP(71))
      AMP2(52)=AMP2(52)+AMP(58)*DCONJG(AMP(58))
      AMP2(53)=AMP2(53)+AMP(59)*DCONJG(AMP(59))
      AMP2(56)=AMP2(56)+AMP(64)*DCONJG(AMP(64))
      AMP2(57)=AMP2(57)+AMP(65)*DCONJG(AMP(65))
      AMP2(75)=AMP2(75)+AMP(83)*DCONJG(AMP(83))
      AMP2(74)=AMP2(74)+AMP(82)*DCONJG(AMP(82))
      AMP2(73)=AMP2(73)+AMP(81)*DCONJG(AMP(81))
      AMP2(77)=AMP2(77)+AMP(85)*DCONJG(AMP(85))
      AMP2(76)=AMP2(76)+AMP(84)*DCONJG(AMP(84))
      AMP2(70)=AMP2(70)+AMP(78)*DCONJG(AMP(78))
      AMP2(65)=AMP2(65)+AMP(73)*DCONJG(AMP(73))
      AMP2(66)=AMP2(66)+AMP(74)*DCONJG(AMP(74))
      AMP2(67)=AMP2(67)+AMP(75)*DCONJG(AMP(75))
      AMP2(79)=AMP2(79)+AMP(87)*DCONJG(AMP(87))
      AMP2(78)=AMP2(78)+AMP(86)*DCONJG(AMP(86))
      AMP2(68)=AMP2(68)+AMP(76)*DCONJG(AMP(76))
      AMP2(69)=AMP2(69)+AMP(77)*DCONJG(AMP(77))
      AMP2(71)=AMP2(71)+AMP(79)*DCONJG(AMP(79))
      AMP2(72)=AMP2(72)+AMP(80)*DCONJG(AMP(80))
      AMP2(1)=AMP2(1)+AMP(1)*DCONJG(AMP(1))
      AMP2(2)=AMP2(2)+AMP(2)*DCONJG(AMP(2))
      AMP2(3)=AMP2(3)+AMP(3)*DCONJG(AMP(3))
      AMP2(4)=AMP2(4)+AMP(4)*DCONJG(AMP(4))
      AMP2(5)=AMP2(5)+AMP(5)*DCONJG(AMP(5))
      AMP2(6)=AMP2(6)+AMP(6)*DCONJG(AMP(6))
      AMP2(7)=AMP2(7)+AMP(7)*DCONJG(AMP(7))
      AMP2(8)=AMP2(8)+AMP(8)*DCONJG(AMP(8))
      AMP2(9)=AMP2(9)+AMP(9)*DCONJG(AMP(9))
      AMP2(10)=AMP2(10)+AMP(10)*DCONJG(AMP(10))
      AMP2(11)=AMP2(11)+AMP(11)*DCONJG(AMP(11))
      AMP2(12)=AMP2(12)+AMP(12)*DCONJG(AMP(12))
      AMP2(13)=AMP2(13)+AMP(13)*DCONJG(AMP(13))
      AMP2(14)=AMP2(14)+AMP(14)*DCONJG(AMP(14))
      AMP2(15)=AMP2(15)+AMP(15)*DCONJG(AMP(15))
      AMP2(109)=AMP2(109)+AMP(127)*DCONJG(AMP(127))
      AMP2(110)=AMP2(110)+AMP(128)*DCONJG(AMP(128))
      AMP2(94)=AMP2(94)+AMP(104)*DCONJG(AMP(104))
      AMP2(93)=AMP2(93)+AMP(103)*DCONJG(AMP(103))
      AMP2(101)=AMP2(101)+AMP(113)*DCONJG(AMP(113))
      AMP2(100)=AMP2(100)+AMP(112)*DCONJG(AMP(112))
      AMP2(111)=AMP2(111)+AMP(129)*DCONJG(AMP(129))
      AMP2(112)=AMP2(112)+AMP(130)*DCONJG(AMP(130))
      AMP2(88)=AMP2(88)+AMP(98)*DCONJG(AMP(98))
      AMP2(87)=AMP2(87)+AMP(97)*DCONJG(AMP(97))
      AMP2(104)=AMP2(104)+AMP(118)*DCONJG(AMP(118))
      AMP2(103)=AMP2(103)+AMP(117)*DCONJG(AMP(117))
      AMP2(113)=AMP2(113)+AMP(131)*DCONJG(AMP(131))
      AMP2(114)=AMP2(114)+AMP(132)*DCONJG(AMP(132))
      AMP2(90)=AMP2(90)+AMP(100)*DCONJG(AMP(100))
      AMP2(89)=AMP2(89)+AMP(99)*DCONJG(AMP(99))
      AMP2(96)=AMP2(96)+AMP(106)*DCONJG(AMP(106))
      AMP2(95)=AMP2(95)+AMP(105)*DCONJG(AMP(105))
      AMP2(81)=AMP2(81)+AMP(91)*DCONJG(AMP(91))
      AMP2(82)=AMP2(82)+AMP(92)*DCONJG(AMP(92))
      AMP2(83)=AMP2(83)+AMP(93)*DCONJG(AMP(93))
      AMP2(84)=AMP2(84)+AMP(94)*DCONJG(AMP(94))
      AMP2(85)=AMP2(85)+AMP(95)*DCONJG(AMP(95))
      AMP2(86)=AMP2(86)+AMP(96)*DCONJG(AMP(96))
      AMP2(107)=AMP2(107)+AMP(123)*DCONJG(AMP(123))
      AMP2(106)=AMP2(106)+AMP(122)*DCONJG(AMP(122))
      AMP2(98)=AMP2(98)+AMP(108)*DCONJG(AMP(108))
      AMP2(97)=AMP2(97)+AMP(107)*DCONJG(AMP(107))
      AMP2(91)=AMP2(91)+AMP(101)*DCONJG(AMP(101))
      AMP2(92)=AMP2(92)+AMP(102)*DCONJG(AMP(102))
      DO I = 1, NCOLOR
        JAMP2(I)=JAMP2(I)+JAMP(I)*DCONJG(JAMP(I))
      ENDDO

      END

